<?php

namespace Controller;

use Traits\TResponse;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

class Structure
{
    use TResponse;

    /**
     * @var \Service\Structure
     */
    private $structureService;

    public function __construct(\Service\Structure $structureService)
    {
        $this->structureService = $structureService;
    }


    public function findStructureFieldNext(Request $request, Response $response)
    {
        try {
            $versions = $this->structureService->findStructureFieldNext();
            $this->sendResponse($versions, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

}
