<?php

namespace Repository;

use Util\InstanceProvider;
use Zeedhi\DevOps\Util\Utilities;
use Teknisa\Model\Traits\TQuery;

class CpCallOperador
{
    use TQuery;

    const CLASS_ENTITIES = '\Teknisa\Model\Teknisa\Entities\CpCallOperador';

    public function getEntityManager(){
        return InstanceProvider::getEntityManager();
    }

    public function findBy($filter){
        return InstanceProvider::getEntityManager()->getRepository(self::CLASS_ENTITIES)->findBy($filter);
    }

    public function findAllResponsibleIssue($issue)
    {
        $query = <<<SQL
         SELECT RT.EXTERNAL_CODE
				FROM TASK TAS
				JOIN PROJECT PRC ON(PRC.ID = TAS.PROJECT)
				JOIN RESOURCE_PROJECT RP ON RP.PROJECT = PRC.ID AND RP.TYPE = 'M'
				JOIN RESOURCE_T RT ON RT.ID = RP.RESOURCE_C
				WHERE TAS.ID = :ISSUE
SQL;

        $params = array(
            "ISSUE" => $issue,
        );
        $result =  $this->getEntityManager()->getConnection()->fetchAllAssociative($query, $params);
        return $result;
    }

}
