<?php


namespace Service;

use Util\InstanceProvider;
use Zeedhi\Framework\Session\Session;
use \Util\Utilities;
use \Doctrine\ORM\EntityManager;

class Resource
{
    /**
     * @var EntityManager
     */
    private $entityManager;
    /**
     * @var Utilities
     */
    private $environment;
    /**
     * @var Session
     */
    private $sessionManager;

    public function __construct(EntityManager $entityManager, Utilities $environment, Session $sessionManager)
    {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->sessionManager = $sessionManager;
    }

    public function setSessionByCdOperador($cdOperador)
    {

        if($cdOperador){
            /** @var Entities\Resource $currentResource */
            $resourceRepository = InstanceProvider::getRepository()->getResource();
            $currentResource = $resourceRepository->findOneBy(array('externalCode' => $this->environment->getCurrentCdoperador()));
            $this->sessionManager->set('organizationId', $currentResource->getOrganization());
            $this->sessionManager->set('userId', $currentResource->getId());
        }
    }
}
