/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PROPSERVICO                                              */
/* Tabela : PROPSERVICO                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 03/12/2003 Mariana Costa                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PROPSERVICO
BEFORE INSERT OR UPDATE OR DELETE
ON PROPSERVICO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPSRV := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUPSRV := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PROPSERVICO','',
                               'CDSERVICO='||:OLD.CDSERVICO||
                               ';QTPAXDE='||:OLD.QTPAXDE||
                               ';QTPAXATE='||:OLD.QTPAXATE||
                               ';CDFILIAL='||:OLD.CDFILIAL||
                               ';CDCIA='||:OLD.CDCIA||
                               ';NRVOO='||:OLD.NRVOO||
                               ';CDTRECHO='||:OLD.CDTRECHO||
                               ';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PROPSERVICO MODIFY DTULTATUPSRV DEFAULT SYSDATE
/
