<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

class GpeMnemonico extends \Doctrine\ORM\EntityRepository {
    
    public function getDadosEndereco($params) {

        $sql = <<<SQL
SELECT MP.*, PA.*, EP.*
  FROM ENDERECOPARC EP
  LEFT JOIN PAIS PA ON PA.CDPAIS = EP.CDPAIS
  LEFT JOIN MUNICIPIO MP ON MP.CDPAIS = EP.CDPAIS
                        AND MP.SGESTADO = EP.SGESTADO
                        AND MP.CDMUNICIPIO = EP.CDMUNICIPIO
 WHERE EP.NRORG = :P_NRORG
   AND EP.NRPARCNEGOCIO = :P_NRPARCNEGOCIO
   AND EP.CDTIPOENDERECO = :P_CDTIPOENDERECO
SQL;
        
        $param = array(
            'P_NRORG' => $params['nrorg'],
            'P_NRPARCNEGOCIO' => $params['NRPARCNEGOCIO'],
            'P_CDTIPOENDERECO' => 'PRINCIPAL' //$params['DSPARAMAUX'],
        );
        
        return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAssoc($sql, $param);
        
    }
    
    public function getDadosComunicacao($params) {
        
        $sql = <<<SQL
SELECT CP.*
  FROM COMUNICAPARC CP
 WHERE CP.NRORG = :P_NRORG
   AND CP.NRPARCNEGOCIO = :P_NRPARCNEGOCIO
   AND CP.CDFORMACOMU = :P_CDFORMACOMU
SQL;
        
        $param = array(
            'P_NRORG' => $params['nrorg'],
            'P_NRPARCNEGOCIO' => $params['NRPARCNEGOCIO'],
            'P_CDFORMACOMU' => '01' //$params['DSPARAMAUX'],
        );
        
        return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAssoc($sql, $param);
        
    }
    
    public function getDadosPessoa($params) {
        
        $sql = <<<SQL
SELECT TC.*, CC.*, GI.*, EC.*, RP.*, NA.*, MU.*, PA.*, PE.*, PH.*
  FROM GPE_PESSOA PE
  JOIN GPE_PESSOAH PH ON PH.NRORG = PE.NRORG
                     AND PH.NRPESSOA = PE.NRPESSOA
                     AND PH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_PESSOAH H1
                                               WHERE H1.NRORG = PH.NRORG
                                                 AND H1.NRPESSOA = PH.NRPESSOA
                                                 AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Naturalidade*/
  LEFT JOIN PAIS PA ON PA.CDPAIS = PH.CDPAIS
  LEFT JOIN MUNICIPIO MU ON MU.CDPAIS = PH.CDPAIS
                        AND MU.SGESTADO = PH.SGESTADO
                        AND MU.CDMUNICIPIO = PH.CDMUNICIPIO
  /*Nacionalidade*/
  LEFT JOIN GPE_NACIONALIDADE NA ON PH.NRNACIONALID = NA.NRNACIONALIDADE
                                AND (PH.NRORG = NA.NRORG OR NA.NRORG = :P_NRORG_PADRAO)
  /*RaçaCor*/
  LEFT JOIN GPE_RACAPESSOA RP ON RP.NRRACAPESSOA = PH.NRRACAPESSOA
                             AND (RP.NRORG = PH.NRORG OR RP.NRORG = :P_NRORG_PADRAO)
  /*Estado Civil*/
  LEFT JOIN ESTADOCIVIL EC ON EC.CDESTACIVIL = PH.CDESTACIVIL
                          AND (EC.NRORG = PH.NRORG OR EC.NRORG = :P_NRORG_PADRAO)
  /*Grau Instrução*/
  LEFT JOIN GPE_GRAUINSTR GI ON GI.NRGRAUINSTR = PH.NRGRAUINSTR
                            AND (GI.NRORG = PH.NRORG OR GI.NRORG = :P_NRORG_PADRAO)
  /*Conta Corrente*/
  LEFT JOIN CONTCORRPARC CC ON CC.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                           AND CC.NRORG = PE.NRORG
  LEFT JOIN TPCONTCORR TC ON CC.NRTPCONTCORR = TC.NRTPCONTCORR
                         AND (CC.NRORG = TC.NRORG OR TC.NRORG = :P_NRORG_PADRAO)
 WHERE PE.NRORG = :P_NRORG
   AND PE.NRPESSOA = :P_NRPESSOA
SQL;
        
        $param = array(
            'P_NRORG' => $params['nrorg'],
            'P_NRORG_PADRAO' => $params['nrorgpadrao'],
            'P_DTMESCOMPETENC' => $params['dtmescompetenc'],
            'P_NRPESSOA' => $params['NRPESSOA'],

        );
        
        return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAssoc($sql, $param);
        
    }
    
    public function getDadosGeraisVinculo($params) {
        
        $sql = <<<SQL
SELECT AN.*, FX.*, MS.*, CA.*, AP.*, MR.*, TD.*, TA.*, VE.*, TV.*, VM.*, VH.*,
    VM.DTADMISSAOVINC + VM.NRDIASCONTRATOEXP - 1                                DTFIMEXPERIENCIA,
    VM.DTADMISSAOVINC + VM.NRDIASCONTRATOEXP + NVL(NRDIASCONTRATOEXPPRO, 0) - 1 DTFIMEXPERIENCIAPROR
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                   AND VH.NRVINCULOM = VM.NRVINCULOM
                   AND VH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                             WHERE H1.NRORG = VH.NRORG
                                               AND H1.NRVINCULOM = VH.NRVINCULOM
                                               AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  LEFT JOIN GPE_TIPOVINCULOH TV ON (TV.NRORG = VM.NRORG OR TV.NRORG = :P_NRORG_PADRAO)
                                AND TV.NRTIPOVINCULOM = VM.NRTIPOVINCULOM
                                AND TV.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_TIPOVINCULOH H1
                                                          WHERE H1.NRORG = TV.NRORG
                                                            AND H1.NRTIPOVINCULOM = TV.NRTIPOVINCULOM
                                                            AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  LEFT JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN FPA_TPADMISSAO TA ON TA.NRTPADMISSAO = VM.NRTPADMISSAO
                             AND ( TA.NRORG = VM.NRORG OR TA.NRORG = :P_NRORG_PADRAO )
  LEFT JOIN FPA_TPDEMISSAO TD ON VM.NRTPDEMISSAO = TD.NRTPDEMISSAO
                             AND ( VM.NRORG = TD.NRORG OR TD.NRORG = :P_NRORG_PADRAO )
  LEFT JOIN GPE_MOTIVORESC MR ON VM.NRMOTIVORESC = MR.NRMOTIVORESC
                             AND ( VM.NRORG = MR.NRORG OR MR.NRORG = :P_NRORG_PADRAO )
  LEFT JOIN GPE_TIPOAVISOPRE AP ON AP.NRTPAVIPRE = VM.NRTPAVIPRE
                               AND ( AP.NRORG = VM.NRORG OR AP.NRORG = :P_NRORG_PADRAO )
  LEFT JOIN GPE_MOTIVOCANCAP CA ON CA.NRMOTIVOCANCAP = VM.NRMOTIVOCANCAP
                            AND ( CA.NRORG = VM.NRORG OR CA.NRORG = :P_NRORG_PADRAO )
  LEFT JOIN FPA_TPMODALIDSAL MS ON MS.NRTPMODALIDSAL = VH.NRTPMODALIDSAL
                                AND ( VH.NRORG = MS.NRORG OR MS.NRORG = :P_NRORG_PADRAO )
  LEFT JOIN GSO_FAIXA FX ON FX.NRFAIXA = VH.NRFAIXA
                        AND ( FX.NRORG = VH.NRORG OR FX.NRORG = :P_NRORG_PADRAO )
  LEFT JOIN GPE_AGENTENOCIVO AN ON ( AN.NRORG = VH.NRORG OR AN.NRORG = :P_NRORG_PADRAO )
                               AND AN.NRAGENTENOCIVO= VH.NRAGENTENOCIVO
 WHERE VM.NRORG = :P_NRORG
   AND VM.NRVINCULOM = :P_NRVINCULOM
SQL;
        
        $param = array(
            'P_NRORG' => $params['nrorg'],
            'P_NRORG_PADRAO' => $params['nrorgpadrao'],
            'P_DTMESCOMPETENC' => $params['dtmescompetenc'],
            'P_NRVINCULOM' => $params['NRVINCULOM'],
        );
        
        return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAssoc($sql, $param);
        
    }
    
    public function getDadosAtuaisVinculo($params) {
        
        $sql = <<<SQL
SELECT ASF.*, SH.*, AOC.*, OH.*, AES.*, EH.*, TU.*, ASL.*, TA.*, TM.*, TS.*,
  EXTENSO_MONETARIO(ROUND(ASL.VRSALARIO, 2)) VRSALEXTENSO,
  ROUND( DECODE( NVL( ASL.VRSALARIOHR, 0 ), 0, ASL.VRSALARIO / ( EH.QTHRSEMESCTRABH * 5 ), ASL.VRSALARIOHR ), 5 )                      VRSALARIOHR,
  EXTENSO_MONETARIO( ROUND( DECODE( NVL( ASL.VRSALARIOHR, 0 ), 0, ASL.VRSALARIO / ( EH.QTHRSEMESCTRABH * 5 ), ASL.VRSALARIOHR ), 5 ) ) VRSALHREXTENSO,
  TRIM( TO_CHAR( EH.QTHRSEMENAGEREN, '9999999.99' ) ) QTHRSEMENAGEREN,
  REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( REPLACE(
    EXTENSO_MONETARIO( ROUND( EH.QTHRSEMENAGEREN, 2 ) ),
      ' Reais e',  ' vírgula' ),
      ' Reais',    ' vírgula' ),
      ' Real e',   ' vírgula' ),
      ' Real',     ''         ),
      ' Centavos', ''         ),
      ' Centavo',  ''         ) QTHRSEMENAGEREN_EXT,
  TRIM( TO_CHAR( EH.QTHRESCALAGEREN, '9999999.99' ) ) QTHRESCALAGEREN,
  REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( REPLACE(
    EXTENSO_MONETARIO( ROUND( EH.QTHRESCALAGEREN, 2 ) ),
      ' Reais e',  ' vírgula' ),
      ' Reais',    ' vírgula' ),
      ' Real e',   ' vírgula' ),
      ' Real',     ''         ),
      ' Centavos', ''         ),
      ' Centavo',  ''         ) QTHRESCALAGEREN_EXT
FROM GPE_VINCULOM VM
LEFT JOIN GPE_ALTESITUFUNC ASF ON ASF.NRORG = VM.NRORG
                              AND ASF.NRVINCULOM = VM.NRVINCULOM
                              AND ASF.DTINISITUFUNC = (SELECT MAX(H1.DTINISITUFUNC) FROM GPE_ALTESITUFUNC H1
                                                        WHERE H1.NRORG = ASF.NRORG
                                                          AND H1.NRVINCULOM = ASF.NRVINCULOM
                                                          AND H1.DTINISITUFUNC <= LAST_DAY(:P_DTMESCOMPETENC)
                                                          AND (H1.DTFIMSITUFUNC IS NULL OR H1.DTFIMSITUFUNC >= LAST_DAY(:P_DTMESCOMPETENC)))
                              AND (ASF.DTFIMSITUFUNC IS NULL OR ASF.DTFIMSITUFUNC >= LAST_DAY(:P_DTMESCOMPETENC))
LEFT JOIN GPE_SITUFUNCH SH ON SH.NRSITUFUNCM = ASF.NRSITUFUNCM
                          AND SH.DTEFETIVA = (SELECT MAX(H1.DTEFETIVA) FROM GPE_SITUFUNCH H1
                                                    WHERE H1.NRSITUFUNCM = SH.NRSITUFUNCM
                                                      AND H1.DTEFETIVA <= LAST_DAY(:P_DTMESCOMPETENC))
LEFT JOIN GPE_ALTEOCUPACAO AOC ON AOC.NRORG = VM.NRORG
                              AND AOC.NRVINCULOM = VM.NRVINCULOM
                              AND AOC.DTINIOCUPACAO = (SELECT MAX(H1.DTINIOCUPACAO) FROM GPE_ALTEOCUPACAO H1
                                                        WHERE H1.NRORG = AOC.NRORG
                                                          AND H1.NRVINCULOM = AOC.NRVINCULOM
                                                          AND H1.DTINIOCUPACAO <= LAST_DAY(:P_DTMESCOMPETENC)
                                                          AND (H1.DTFIMOCUPACAO IS NULL OR H1.DTFIMOCUPACAO >= LAST_DAY(:P_DTMESCOMPETENC)))
                              AND (AOC.DTFIMOCUPACAO IS NULL OR AOC.DTFIMOCUPACAO >= LAST_DAY(:P_DTMESCOMPETENC))
LEFT JOIN GPE_OCUPACAOH OH ON OH.NRORG = AOC.NRORG
                          AND OH.NROCUPACAOM = AOC.NROCUPACAOM
                          AND OH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_OCUPACAOH H1
                                                    WHERE H1.NRORG = OH.NRORG
                                                      AND H1.NROCUPACAOM = OH.NROCUPACAOM
                                                      AND H1.DTMESCOMPETENC <= LAST_DAY(:P_DTMESCOMPETENC))
LEFT JOIN GPE_ALTEESCALA AES ON AES.NRORG = VM.NRORG
                            AND AES.NRVINCULOM = VM.NRVINCULOM
                            AND AES.DTINIESCALA = (SELECT MAX(H1.DTINIESCALA) FROM GPE_ALTEESCALA H1
                                                    WHERE H1.NRORG = AES.NRORG
                                                      AND H1.NRVINCULOM = AES.NRVINCULOM
                                                      AND H1.DTINIESCALA <= LAST_DAY(:P_DTMESCOMPETENC)
                                                      AND (H1.DTFIMESCALA IS NULL OR H1.DTFIMESCALA >= LAST_DAY(:P_DTMESCOMPETENC)))
                            AND (AES.DTFIMESCALA IS NULL OR AES.DTFIMESCALA >= LAST_DAY(:P_DTMESCOMPETENC))
LEFT JOIN GPE_ESCALATRABH EH ON EH.NRORG = AES.NRORG
                            AND EH.NRESCALATRABM = AES.NRESCALATRABM
                            AND EH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_ESCALATRABH H1
                                                      WHERE H1.NRORG = EH.NRORG
                                                        AND H1.NRESCALATRABM = EH.NRESCALATRABM
                                                        AND H1.DTMESCOMPETENC <= LAST_DAY(:P_DTMESCOMPETENC))
LEFT JOIN GPE_TURNO TU ON TU.NRORG = AES.NRORG
                      AND TU.NRTURNO = AES.NRTURNO
LEFT JOIN GPE_ALTESALARIO ASL ON ASL.NRORG = VM.NRORG
                             AND ASL.NRVINCULOM = VM.NRVINCULOM
                             AND ASL.DTALTESALARIO = (SELECT MAX(H1.DTALTESALARIO) FROM GPE_ALTESALARIO H1
                                                       WHERE H1.NRORG = ASL.NRORG
                                                         AND H1.NRVINCULOM = ASL.NRVINCULOM
                                                         AND H1.DTALTESALARIO <= LAST_DAY(:P_DTMESCOMPETENC))
LEFT JOIN GPE_TIPOALTERA TA ON TA.NRTIPOALTERA = ASL.NRTIPOALTERA
                           AND ( TA.NRORG = ASL.NRORG OR TA.NRORG = :P_NRORG_PADRAO )
LEFT JOIN FPA_TPMODALIDSAL TM ON TM.NRTPMODALIDSAL = ASL.NRTPMODALIDSAL
                             AND ( TM.NRORG = ASL.NRORG OR TM.NRORG = :P_NRORG_PADRAO )
LEFT JOIN GPE_TIPOSALARIO TS ON TS.CDTIPOSALARIO = ASL.IDTPSALARIO
                            AND ( TS.NRORG = ASL.NRORG OR TS.NRORG = :P_NRORG_PADRAO )
WHERE VM.NRORG = :P_NRORG
 AND VM.NRVINCULOM = :P_NRVINCULOM
SQL;
        
        $param = array(
            'P_NRORG' => $params['nrorg'],
            'P_NRORG_PADRAO' => $params['nrorgpadrao'],
            'P_DTMESCOMPETENC' => $params['dtmescompetenc'],
            'P_NRVINCULOM' => $params['NRVINCULOM'],
        );
        
        return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAssoc($sql, $param);
        
    }
    
    public function getDadosComplementaresVinculo($params) {
        
        $sql = <<<SQL
SELECT DECODE(VH.IDCONTRIBUISIND,'NUNCA','Nunca','DESCONTOU','Descontou','SEMPRE','Sempre',NULL) DSCONTRIBUISIND,
       (SELECT NVL(COUNT(*),0) FROM FPA_DEPVINCULO WHERE NRVINCULOM = VM.NRVINCULOM AND NRORG = VM.NRORG AND NRTIPODEPENDE = '2') NRDEPENDIR,
       (SELECT NVL(COUNT(*),0) FROM FPA_DEPVINCULO WHERE NRVINCULOM = VM.NRVINCULOM AND NRORG = VM.NRORG AND NRTIPODEPENDE = '1') NRDEPENDSFAM,
       VH.DTBASEFERIAS,
       DECODE(VH.IDREMUNERACAO,'SAL1','Salário Mensal','SAL1_RSR','Salário Mensal RSR','SAL2','Salário Hora','SAL2_RSR','Salário Hora RSR','ESTAGIO','Estágio','SOCIO','Sócio','AUTONOMO','Autônomo','NENHUM','Nenhum',NULL) DSREMUNERACAO,
       DECODE(VH.IDTPPAGAMENTO,'QUINZENAL','Quinzenal','DIARIO','Diário','MENSAL','Mensal','MENSAL_SALARIO_HORA','Mensal Salário Hora','SEMANAL','Semanal',NULL) DSTPPAGAMENTO
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                   AND VH.NRVINCULOM = VM.NRVINCULOM
                   AND VH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                             WHERE H1.NRORG = VH.NRORG
                                               AND H1.NRVINCULOM = VH.NRVINCULOM
                                               AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
 WHERE VM.NRORG = :P_NRORG
   AND VM.NRVINCULOM = :P_NRVINCULOM
SQL;
        
        $param = array(
            'P_NRORG' => $params['nrorg'],
            'P_DTMESCOMPETENC' => $params['dtmescompetenc'],
            'P_NRVINCULOM' => $params['NRVINCULOM'],
        );
        
        return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAssoc($sql, $param);
        
    }
    
    public function getDadosEstruturaLegal($params) {
        
        $sql = <<<SQL
SELECT MP.*, PA.*, EP.*, PN.*, EM.*, EH.*,
       PR.NMPRINCIPALPARC NMPROPRIEMPRLEGAL, RI.NMPRINCIPALPARC NMPARCRESPINFLEGAL, ES.NMPRINCIPALPARC NMPARCENTISINLEGAL
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                               FROM ESTRUTURAH H1
                                              WHERE H1.NRORG = EH.NRORG
                                                AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                    /*AND EH.DTMESCOMPETENC = P_DTMESCOMPETENCIA*/
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                     AND PN.NRORG = EH.NRORG
  /*Endereço Principal*/
  LEFT JOIN ENDERECOPARC EP ON PN.NRPARCNEGOCIO = EP.NRPARCNEGOCIO
                           AND PN.NRORG = EP.NRORG
                           AND EP.CDTIPOENDERECO = 'PRINCIPAL'
  LEFT JOIN PAIS PA ON PA.CDPAIS = EP.CDPAIS
  LEFT JOIN MUNICIPIO MP ON MP.CDPAIS = EP.CDPAIS
                        AND MP.SGESTADO = EP.SGESTADO
                        AND MP.CDMUNICIPIO = EP.CDMUNICIPIO
  /*Proprietario*/
  LEFT JOIN PARCNEGOCIO PR ON PR.NRPARCNEGOCIO = EH.NRPARCENTISIN
                          AND PR.NRORG = EH.NRORG
  /*Responsável Informal*/
  LEFT JOIN PARCNEGOCIO RI ON RI.NRPARCNEGOCIO = EH.NRPARCENTISIN
                          AND RI.NRORG = EH.NRORG
  /*Entidade Sindical*/
  LEFT JOIN PARCNEGOCIO ES ON ES.NRPARCNEGOCIO = EH.NRPARCENTISIN
                          AND ES.NRORG = EH.NRORG
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRESTRUTURAM = :P_NRESTRUTURAM
SQL;
        
        $param = array(
            'P_NRORG' => $params['nrorg'],
            'P_DTMESCOMPETENC' => $params['dtmescompetenc'],
            'P_NRESTRUTURAM' => $params['NRESTRUTLEGAL'],
        );
        
        return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAssoc($sql, $param);
        
    }
    
    public function getDadosEstruturaGerencial($params) {
        
        $sql = <<<SQL
SELECT MP.*, PA.*, EP.*, PN.*, EM.*, EH.*,
       PR.NMPRINCIPALPARC NMPROPRIEMPRGERENCIAL, RI.NMPRINCIPALPARC NMPARCRESPINFGERENCIAL, ES.NMPRINCIPALPARC NMPARCENTISINGERENCIAL
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                               FROM ESTRUTURAH H1
                                              WHERE H1.NRORG = EH.NRORG
                                                AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                    /*AND EH.DTMESCOMPETENC = P_DTMESCOMPETENCIA*/
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                     AND PN.NRORG = EH.NRORG
  /*Endereço Principal*/
  LEFT JOIN ENDERECOPARC EP ON PN.NRPARCNEGOCIO = EP.NRPARCNEGOCIO
                           AND PN.NRORG = EP.NRORG
                           AND EP.CDTIPOENDERECO = 'PRINCIPAL'
  LEFT JOIN PAIS PA ON PA.CDPAIS = EP.CDPAIS
  LEFT JOIN MUNICIPIO MP ON MP.CDPAIS = EP.CDPAIS
                        AND MP.SGESTADO = EP.SGESTADO
                        AND MP.CDMUNICIPIO = EP.CDMUNICIPIO
  /*Proprietario*/
  LEFT JOIN PARCNEGOCIO PR ON PR.NRPARCNEGOCIO = EH.NRPARCENTISIN
                          AND PR.NRORG = EH.NRORG
  /*Responsável Informal*/
  LEFT JOIN PARCNEGOCIO RI ON RI.NRPARCNEGOCIO = EH.NRPARCENTISIN
                          AND RI.NRORG = EH.NRORG
  /*Entidade Sindical*/
  LEFT JOIN PARCNEGOCIO ES ON ES.NRPARCNEGOCIO = EH.NRPARCENTISIN
                          AND ES.NRORG = EH.NRORG
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRESTRUTURAM = :P_NRESTRUTURAM
SQL;
        
        $param = array(
            'P_NRORG' => $params['nrorg'],
            'P_DTMESCOMPETENC' => $params['dtmescompetenc'],
            'P_NRESTRUTURAM' => $params['NRESTRUTGEREN'],
        );
        
        return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAssoc($sql, $param);
        
    }
    
    public function getDadosEstruturaSindical($params) {
        
        $sql = <<<SQL
SELECT MP.*, PA.*, EP.*, PN.*, EM.*, EH.*,
       PR.NMPRINCIPALPARC NMPROPRIEMPRSIND, RI.NMPRINCIPALPARC NMPARCRESPINFSIND, ES.NMPRINCIPALPARC NMPARCENTISINSIND
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                               FROM ESTRUTURAH H1
                                              WHERE H1.NRORG = EH.NRORG
                                                AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                    /*AND EH.DTMESCOMPETENC = P_DTMESCOMPETENCIA*/
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                     AND PN.NRORG = EH.NRORG
  /*Endereço Principal*/
  LEFT JOIN ENDERECOPARC EP ON PN.NRPARCNEGOCIO = EP.NRPARCNEGOCIO
                           AND PN.NRORG = EP.NRORG
                           AND EP.CDTIPOENDERECO = 'PRINCIPAL'
  LEFT JOIN PAIS PA ON PA.CDPAIS = EP.CDPAIS
  LEFT JOIN MUNICIPIO MP ON MP.CDPAIS = EP.CDPAIS
                        AND MP.SGESTADO = EP.SGESTADO
                        AND MP.CDMUNICIPIO = EP.CDMUNICIPIO
  /*Proprietario*/
  LEFT JOIN PARCNEGOCIO PR ON PR.NRPARCNEGOCIO = EH.NRPARCENTISIN
                          AND PR.NRORG = EH.NRORG
  /*Responsável Informal*/
  LEFT JOIN PARCNEGOCIO RI ON RI.NRPARCNEGOCIO = EH.NRPARCENTISIN
                          AND RI.NRORG = EH.NRORG
  /*Entidade Sindical*/
  LEFT JOIN PARCNEGOCIO ES ON ES.NRPARCNEGOCIO = EH.NRPARCENTISIN
                          AND ES.NRORG = EH.NRORG
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRESTRUTURAM = :P_NRESTRUTURAM
SQL;
        
        $param = array(
            'P_NRORG' => $params['nrorg'],
            'P_DTMESCOMPETENC' => $params['dtmescompetenc'],
            'P_NRESTRUTURAM' => $params['NRESTRUTSIND'],
        );
        
        return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAssoc($sql, $param);
        
    }
    
}