/* TECNISA - TECNOLOGIA EM INFORMTICA

NOME: CONSULTA INCIDNCIA

DESCRIO:

CRIAO:
30/09/98 - ????????????????

MANUTENES:
08/11/99 PAULO GIOVANNI - CONVERSO P/ SQL-SERVER

 raise_application_error(-20501, '' , True);
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CONSULTA_INCIDENCIA' AND
	        TYPE = 'P' 		       AND
	        U.UID = O.UID                  AND
	        U.NAME = USER)
DROP PROCEDURE CONSULTA_INCIDENCIA
GO

CREATE PROCEDURE CONSULTA_INCIDENCIA
                 @P_ENTRSAIDIN  VARCHAR(01),
                 @P_EMPRESA     VARCHAR(02),
                 @P_PRODUTO     VARCHAR(20),
                 @P_INSCESTA    VARCHAR(16),
                 @P_TIPOOPER    VARCHAR(02),
                 @P_FILIAL      VARCHAR(14),
                 @P_LANCTONF    VARCHAR(10),
                 @P_CDGRUPOFISC VARCHAR(03),
                 @P_CDGRPFISCSV VARCHAR(03) = NULL,
                 @P_IDINCINTEREST VARCHAR(01) = 'N',
                 @P_IDSISTEMA   VARCHAR(03) = NULL,
                 @P_CDFILIRECE  VARCHAR(04) = NULL,           --Exclusivo Unificao
                 @P_CDFORNECED  VARCHAR(21) = NULL,           --Exclusivo Unificao
                 @P_CDCLIENTE   VARCHAR(21) = NULL,           --Exclusivo Unificao
                 @P_INIVALID    DATETIME    = NULL,           --Exclusivo Unificao
                 @P_CDFILIEMIT  VARCHAR(04) = NULL,           --Exclusivo Unificao
                 @P_VRPRODUTO   DOUBLE PRECISION = NULL,      --Exclusivo Unificao
                 @P_LANCPRODUTO VARCHAR(01) = NULL,           --Exclusivo Unificao
                 @P_IDORIGEMPROD VARCHAR(01) = 'N'


AS
   DECLARE @V_SEQUENCIA VARCHAR(02);               

   DECLARE @V_CDARVPROD VARCHAR(20);
   DECLARE @V_CDIMPOSTO VARCHAR(02);

   DECLARE @V_INCID_IDTRATIMPOIN   VARCHAR(01);
   DECLARE @V_INCID_CDIMPOSTO      VARCHAR(02);
   DECLARE @V_INCID_CDFISCAL       VARCHAR(04);
   DECLARE @V_INCID_DSMENSINCID    VARCHAR(120);
   DECLARE @V_INCID_IDINCINTEREST  VARCHAR(01);
   DECLARE @V_INCID_CDMENSAGEM     VARCHAR(03);
   DECLARE @V_INCID_CDDETALHEPROD  VARCHAR(05);
   DECLARE @V_INCID_CDENQLEGALIPI  VARCHAR(03);
   DECLARE @V_INCID_CDCEST         VARCHAR(09);

   DECLARE @V_INCIDN_IDTRATIMPOIN  VARCHAR(01);
   DECLARE @V_INCIDN_CDIMPOSTO     VARCHAR(02);
   DECLARE @V_INCIDN_CDFISCAL      VARCHAR(04);
   DECLARE @V_INCIDN_DSMENSINCID   VARCHAR(120);
   DECLARE @V_INCIDN_IDINCINTEREST  VARCHAR(01);
   DECLARE @V_INCIDN_CDMENSAGEM     VARCHAR(03);
   DECLARE @V_INCIDN_CDDETALHEPROD  VARCHAR(05);
   DECLARE @V_INCIDN_CDENQLEGALIPI  VARCHAR(03);
   DECLARE @V_INCIDN_CDCEST         VARCHAR(09);

   DECLARE @V_IMPFILI_CDIMPOSTO    VARCHAR(02);
   DECLARE @V_IMPFILI_CDGRUPOFISC  VARCHAR(03);

   DECLARE @V_IMPINSCESTAFO_CDIMPOSTO    VARCHAR(02);
   DECLARE @V_IMPINSCESTAFO_CDGRUPOFISC  VARCHAR(03);

   DECLARE @V_IMPINSCESTACL_CDIMPOSTO    VARCHAR(02);
   DECLARE @V_IMPINSCESTACL_CDGRUPOFISC  VARCHAR(03);

   DECLARE @V_EXISTE               INTEGER;
   DECLARE @V_DSMENSINCID          VARCHAR(120);
   DECLARE @B_INCINTEREST          INTEGER;
   DECLARE @V_COUNTMENS            INTEGER;
   DECLARE @V_COUNT                INTEGER;

   DECLARE @V_NRINCITEMP           VARCHAR(18);

   DECLARE @V_INIVALID       DATETIME;
   DECLARE @V_PAISORIG       VARCHAR(04); -- Pais de origem (utiliza UF de Origem)
   DECLARE @V_ESTAORIG       VARCHAR(02); -- Estado de origem (utiliza UF de Origem)
   DECLARE @V_MUNIORIG       VARCHAR(04); -- Municipio de origem (utiliza municipio)
   DECLARE @V_PAISDEST       VARCHAR(04);
   DECLARE @V_ESTADEST       VARCHAR(02);
   DECLARE @V_MUNIDEST       VARCHAR(04);
   DECLARE @V_IDENDCFOP      VARCHAR(01);
   DECLARE @V_IDORIGDESTNF   VARCHAR(01);
   DECLARE @V_ORIGDESTOP     VARCHAR(01);
   DECLARE @V_CDCLIENTE      VARCHAR(21);
   DECLARE @V_CDORIGDESTNF   VARCHAR(21);
   DECLARE @V_IDENDEMIS      VARCHAR(01);
   DECLARE @V_CDEMPRESA      VARCHAR(02);
   DECLARE @V_CDINSCESTA     VARCHAR(16);
   DECLARE @V_CDFILIRECE     VARCHAR(04);
   DECLARE @V_CDFORNECED     VARCHAR(21);
   DECLARE @V_CDFILIEMIT     VARCHAR(04);
   DECLARE @V_IDTRATIMPO     VARCHAR(01);
   DECLARE @V_VRITEM         DOUBLE PRECISION;

   DECLARE @V_REGRA_CDIMPOSTO VARCHAR(02);
   DECLARE @V_REGRA_CDFISCAL  VARCHAR(01);
   DECLARE @V_REGRA_CDREGRAFISC VARCHAR(10);
   DECLARE @V_REGRA_IDMENSAGEM     VARCHAR(01);
   DECLARE @V_REGRA_IDTIPOREGISTRO VARCHAR(04);
   DECLARE @V_REGRA_NRSEQDADOSFISC VARCHAR(10);
   DECLARE @V_REGRA_CDCLASFISC     VARCHAR(10);
   DECLARE @V_REGRA_CDPRODUTO      VARCHAR(10);
   DECLARE @V_MSGREGRA_DSMENSAGEM  VARCHAR(120);
   DECLARE @V_REGRA_CDDETALHEFISC  VARCHAR(05);
   DECLARE @V_REGRA_CDENQLEGALIPI  VARCHAR(03);
   DECLARE @V_REGRA_CDCEST         VARCHAR(09);
   DECLARE @V_REGRA_VRADICALIQFECP DOUBLE PRECISION;
   
   DECLARE @V_IDNFPRESTSERV        VARCHAR(01);

   DECLARE @V_IDPRESENCIAL         VARCHAR(01);

   DECLARE @V_IDENTEMIS            VARCHAR(01);
BEGIN
   SET @V_SEQUENCIA = '01';

   /*grupo fiscal por servio*/
   IF (@P_CDGRPFISCSV IS NOT NULL) BEGIN

      /* Operao Interestadual */
      IF @P_IDINCINTEREST = 'S' BEGIN

         DECLARE C_IMPOSTO CURSOR FOR
            SELECT MAX(P.CDARVPROD) AS CDARVPROD, I.CDIMPOSTO
            FROM   IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P ON
                           (I.CDPRODUTO    = P.CDPRODUTO)
            WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)                     AND
                  (I.CDEMPRESA    = @P_EMPRESA)                        AND
                  (I.CDTIPOOPER   = @P_TIPOOPER)                       AND
                  (I.CDINSCESTA   = RTRIM(@P_INSCESTA))                AND
                  ((I.CDGRUPOFISC = @P_CDGRPFISCSV) AND (IP.IDGRUPFISSRV = 'S')) AND
                  (I.CDIMPOSTO = IP.CDIMPOSTO)                         AND
                  (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1) AND
                  I.IDINCINTEREST = 'S'
            GROUP BY I.CDIMPOSTO;

         OPEN C_IMPOSTO;

         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SELECT @V_EXISTE = COUNT(*)
              FROM INCITEMP
             WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
               AND CDIMPOTEMP = @V_CDIMPOSTO;

            IF @V_EXISTE > 0 BEGIN
               DELETE FROM INCITEMP
                WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                  AND CDIMPOTEMP = @V_CDIMPOSTO;
            END;

            IF NOT (@V_CDARVPROD IS NULL) BEGIN
                 DECLARE C_INCIDENCIA CURSOR FOR
                    SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                           I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                                ON(I.NRINCIDENCIA = M.NRINCIDENCIA)
                                    LEFT JOIN PRODUTO P
                                              ON (I.CDPRODUTO    = P.CDPRODUTO)
                  WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)      AND
                        (I.CDEMPRESA    = @P_EMPRESA)         AND
                        (I.CDTIPOOPER   = @P_TIPOOPER)        AND
                        (I.CDGRUPOFISC  = @P_CDGRPFISCSV)     AND
                        (I.CDIMPOSTO    = @V_CDIMPOSTO)       AND
                        (I.CDINSCESTA   = RTRIM(@P_INSCESTA)) AND
                        (P.CDARVPROD    = @V_CDARVPROD)       AND
                        I.IDINCINTEREST = 'S';

               OPEN C_INCIDENCIA;
               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                      @V_INCID_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCID_CDDETALHEPROD,
                      @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)

                  FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                    @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                    @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                    @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
               END;
               CLOSE C_INCIDENCIA;
               DEALLOCATE C_INCIDENCIA;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_INCIDNULL CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                  FROM INCIDENCIA I LEFT JOIN MENSINCID M ON
                       (I.NRINCIDENCIA = M.NRINCIDENCIA)
                  WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)      AND
                        (I.CDEMPRESA    = @P_EMPRESA)         AND
                        (I.CDTIPOOPER   = @P_TIPOOPER)        AND
                        (I.CDGRUPOFISC  = @P_CDGRPFISCSV)     AND
                        (I.CDIMPOSTO    = @V_CDIMPOSTO)       AND
                        (I.CDINSCESTA   = RTRIM(@P_INSCESTA)) AND
                        I.IDINCINTEREST = 'S'                 AND
                        (CDPRODUTO IS NULL);

               OPEN C_INCIDNULL;

               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                      @V_INCIDN_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCIDN_CDDETALHEPROD,
                      @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                   @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                   @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
               END;
               CLOSE C_INCIDNULL;
               DEALLOCATE C_INCIDNULL;
            END;
            FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;
         END;
         CLOSE C_IMPOSTO;
         DEALLOCATE C_IMPOSTO;
      END;

      /* Verifica para operaes no interestaduais */
      DECLARE C_IMPOSTO CURSOR FOR
         SELECT MAX(P.CDARVPROD) AS CDARVPROD, I.CDIMPOSTO
         FROM   IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P ON
                        (I.CDPRODUTO    = P.CDPRODUTO)
         WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)                     AND
               (I.CDEMPRESA    = @P_EMPRESA)                        AND
               (I.CDTIPOOPER   = @P_TIPOOPER)                       AND
               (I.CDINSCESTA   = RTRIM(@P_INSCESTA))                AND
               ((I.CDGRUPOFISC = @P_CDGRPFISCSV) AND (IP.IDGRUPFISSRV = 'S')) AND
               (I.CDIMPOSTO = IP.CDIMPOSTO)                         AND
               (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1) AND
               I.IDINCINTEREST = 'N'                                AND
               NOT EXISTS (SELECT NRINCITEMP
                             FROM INCITEMP
                            WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                              AND CDIMPOTEMP = I.CDIMPOSTO)
         GROUP BY I.CDIMPOSTO;

      OPEN C_IMPOSTO;

      FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT @V_EXISTE = COUNT(*)
           FROM INCITEMP
          WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
            AND CDIMPOTEMP = @V_CDIMPOSTO;

         IF @V_EXISTE > 0 BEGIN
            DELETE FROM INCITEMP
             WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
               AND CDIMPOTEMP = @V_CDIMPOSTO;
         END;

         IF NOT (@V_CDARVPROD IS NULL) BEGIN
              DECLARE C_INCIDENCIA CURSOR FOR
                 SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                        I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                             ON(I.NRINCIDENCIA = M.NRINCIDENCIA)
                                 LEFT JOIN PRODUTO P
                                           ON (I.CDPRODUTO    = P.CDPRODUTO)
               WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)      AND
                     (I.CDEMPRESA    = @P_EMPRESA)         AND
                     (I.CDTIPOOPER   = @P_TIPOOPER)        AND
                     (I.CDGRUPOFISC  = @P_CDGRPFISCSV)     AND
                     (I.CDIMPOSTO    = @V_CDIMPOSTO)       AND
                     (I.CDINSCESTA   = RTRIM(@P_INSCESTA)) AND
                     (P.CDARVPROD    = @V_CDARVPROD)       AND
                     I.IDINCINTEREST = 'N';

            OPEN C_INCIDENCIA;
            FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                              @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                              @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                              @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                   @V_INCID_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCID_CDDETALHEPROD,
                   @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)

               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
            END;
            CLOSE C_INCIDENCIA;
            DEALLOCATE C_INCIDENCIA;
         END
         ELSE IF (@V_CDARVPROD IS NULL) BEGIN
            DECLARE C_INCIDNULL CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
               FROM INCIDENCIA I LEFT JOIN MENSINCID M ON
                    (I.NRINCIDENCIA = M.NRINCIDENCIA)
               WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)      AND
                     (I.CDEMPRESA    = @P_EMPRESA)         AND
                     (I.CDTIPOOPER   = @P_TIPOOPER)        AND
                     (I.CDGRUPOFISC  = @P_CDGRPFISCSV)     AND
                     (I.CDIMPOSTO    = @V_CDIMPOSTO)       AND
                     (I.CDINSCESTA   = RTRIM(@P_INSCESTA)) AND
                     I.IDINCINTEREST = 'N'                 AND
                     (CDPRODUTO IS NULL);

            OPEN C_INCIDNULL;

            FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                             @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                             @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                             @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                   @V_INCIDN_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCIDN_CDDETALHEPROD,
                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
            END;
            CLOSE C_INCIDNULL;
            DEALLOCATE C_INCIDNULL;
         END;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;
      END;
      CLOSE C_IMPOSTO;
      DEALLOCATE C_IMPOSTO;
   END;

   /* Se possui grupo fiscal */
   IF (@P_CDGRUPOFISC IS NOT NULL) BEGIN

      /* Operao Interestadual */
      IF @P_IDINCINTEREST = 'S' BEGIN

         DECLARE C_IMPOSTO CURSOR FOR
            SELECT MAX(P.CDARVPROD) AS CDARVPROD, I.CDIMPOSTO
            FROM IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P ON
                           (I.CDPRODUTO    = P.CDPRODUTO)
            WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)                     AND
                  (I.CDEMPRESA    = @P_EMPRESA)                        AND
                  (I.CDTIPOOPER   = @P_TIPOOPER)                       AND
                  (I.CDINSCESTA   = RTRIM(@P_INSCESTA))                AND
                  ((I.CDGRUPOFISC = @P_CDGRUPOFISC) AND (IP.IDGRUPFISSRV <> 'S')) AND
                  (I.CDIMPOSTO    = IP.CDIMPOSTO)                      AND
                  (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1) AND
                  I.IDINCINTEREST = 'S'
            GROUP BY I.CDIMPOSTO;

         OPEN C_IMPOSTO;

         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SELECT @V_EXISTE = COUNT(*)
              FROM INCITEMP
             WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
               AND CDIMPOTEMP = @V_CDIMPOSTO;

            IF @V_EXISTE > 0 BEGIN
               DELETE FROM INCITEMP
                WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                  AND CDIMPOTEMP = @V_CDIMPOSTO;
            END;

            IF NOT (@V_CDARVPROD IS NULL) BEGIN

               DECLARE C_INCIDENCIA CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                  FROM INCIDENCIA I LEFT JOIN MENSINCID M ON
                                   (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                    LEFT JOIN PRODUTO P ON
                                   (I.CDPRODUTO    = P.CDPRODUTO)
                  WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)      AND
                        (I.CDEMPRESA    = @P_EMPRESA)         AND
                        (I.CDTIPOOPER   = @P_TIPOOPER)        AND
                        (I.CDGRUPOFISC  = @P_CDGRUPOFISC)     AND
                        (I.CDIMPOSTO    = @V_CDIMPOSTO)       AND
                        (I.CDINSCESTA   = RTRIM(@P_INSCESTA)) AND
                        I.IDINCINTEREST = 'S'                 AND
                        (P.CDARVPROD    = @V_CDARVPROD);

               OPEN C_INCIDENCIA;
               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                      @V_INCID_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCID_CDDETALHEPROD,
                      @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)

                  FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                    @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                    @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                    @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
               END;
               CLOSE C_INCIDENCIA;
               DEALLOCATE C_INCIDENCIA;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_INCIDNULL CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                  FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                    ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                  WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)      AND
                        (I.CDEMPRESA    = @P_EMPRESA)         AND
                        (I.CDTIPOOPER   = @P_TIPOOPER)        AND
                        (I.CDGRUPOFISC  = @P_CDGRUPOFISC)     AND
                        (I.CDIMPOSTO    = @V_CDIMPOSTO)       AND
                        (I.CDINSCESTA   = RTRIM(@P_INSCESTA)) AND
                        I.IDINCINTEREST = 'S'                 AND
                        (CDPRODUTO IS NULL);

               OPEN C_INCIDNULL;

               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                      @V_INCIDN_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCIDN_CDDETALHEPROD,
                      @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)

                  FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                   @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                   @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
               END;
               CLOSE C_INCIDNULL;
               DEALLOCATE C_INCIDNULL;
            END;
            FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;
         END;
         CLOSE C_IMPOSTO;
         DEALLOCATE C_IMPOSTO;

      END;

      DECLARE C_IMPOSTO CURSOR FOR
         SELECT MAX(P.CDARVPROD) AS CDARVPROD, I.CDIMPOSTO
         FROM IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P ON
                        (I.CDPRODUTO    = P.CDPRODUTO)
         WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)                     AND
               (I.CDEMPRESA    = @P_EMPRESA)                        AND
               (I.CDTIPOOPER   = @P_TIPOOPER)                       AND
               (I.CDINSCESTA   = RTRIM(@P_INSCESTA))                AND
               ((I.CDGRUPOFISC = @P_CDGRUPOFISC) AND (IP.IDGRUPFISSRV <> 'S')) AND
               (I.CDIMPOSTO    = IP.CDIMPOSTO)                      AND
               (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1) AND
               I.IDINCINTEREST = 'N'                                AND
               NOT EXISTS (SELECT NRINCITEMP
                             FROM INCITEMP
                            WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                              AND CDIMPOTEMP = I.CDIMPOSTO)
         GROUP BY I.CDIMPOSTO;

      OPEN C_IMPOSTO;

      FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT @V_EXISTE = COUNT(*)
           FROM INCITEMP
          WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
            AND CDIMPOTEMP = @V_CDIMPOSTO;

         IF @V_EXISTE > 0 BEGIN
            DELETE FROM INCITEMP
             WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
               AND CDIMPOTEMP = @V_CDIMPOSTO;
         END;

         IF NOT (@V_CDARVPROD IS NULL) BEGIN

            DECLARE C_INCIDENCIA CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
               FROM INCIDENCIA I LEFT JOIN MENSINCID M ON
                                (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                 LEFT JOIN PRODUTO P ON
                                (I.CDPRODUTO    = P.CDPRODUTO)
               WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)      AND
                     (I.CDEMPRESA    = @P_EMPRESA)         AND
                     (I.CDTIPOOPER   = @P_TIPOOPER)        AND
                     (I.CDGRUPOFISC  = @P_CDGRUPOFISC)     AND
                     (I.CDIMPOSTO    = @V_CDIMPOSTO)       AND
                     (I.CDINSCESTA   = RTRIM(@P_INSCESTA)) AND
                     I.IDINCINTEREST = 'N'                 AND
                     (P.CDARVPROD    = @V_CDARVPROD);

            OPEN C_INCIDENCIA;
            FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                              @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                              @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                              @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                   @V_INCID_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCID_CDDETALHEPROD,
                   @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)

               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
            END;
            CLOSE C_INCIDENCIA;
            DEALLOCATE C_INCIDENCIA;
         END
         ELSE IF (@V_CDARVPROD IS NULL) BEGIN
            DECLARE C_INCIDNULL CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
               FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                 ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
               WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)      AND
                     (I.CDEMPRESA    = @P_EMPRESA)         AND
                     (I.CDTIPOOPER   = @P_TIPOOPER)        AND
                     (I.CDGRUPOFISC  = @P_CDGRUPOFISC)     AND
                     (I.CDIMPOSTO    = @V_CDIMPOSTO)       AND
                     (I.CDINSCESTA   = RTRIM(@P_INSCESTA)) AND
                     I.IDINCINTEREST = 'N'                 AND
                     (CDPRODUTO IS NULL);

            OPEN C_INCIDNULL;

            FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                             @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                             @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                             @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                   @V_INCIDN_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCIDN_CDDETALHEPROD,
                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)

               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
            END;
            CLOSE C_INCIDNULL;
            DEALLOCATE C_INCIDNULL;
         END;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;
      END;
      CLOSE C_IMPOSTO;
      DEALLOCATE C_IMPOSTO;
   END
   ELSE BEGIN
      /* Operao Interestadual */
      IF @P_IDINCINTEREST = 'S' BEGIN

         DECLARE C_IMPOSTO CURSOR FOR
            SELECT MAX(P.CDARVPROD) AS CDARVPROD, I.CDIMPOSTO
            FROM IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P ON
                           (I.CDPRODUTO    = P.CDPRODUTO)
            WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)                     AND
                  (I.CDEMPRESA    = @P_EMPRESA)                        AND
                  (I.CDTIPOOPER   = @P_TIPOOPER)                       AND
                  (I.CDINSCESTA   = RTRIM(@P_INSCESTA))                AND
                  (I.CDGRUPOFISC IS NULL)                              AND
                  (I.CDIMPOSTO    = IP.CDIMPOSTO)                      AND
                  (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1) AND
                  I.IDINCINTEREST = 'S'
            GROUP BY I.CDIMPOSTO;

         OPEN C_IMPOSTO;

         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SELECT @V_EXISTE = COUNT(*)
              FROM INCITEMP
             WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
               AND CDIMPOTEMP = @V_CDIMPOSTO;

            IF @V_EXISTE > 0 BEGIN
               DELETE FROM INCITEMP
                WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                  AND CDIMPOTEMP = @V_CDIMPOSTO;
            END;

            IF NOT (@V_CDARVPROD IS NULL) BEGIN

               DECLARE C_INCIDENCIA CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                  FROM INCIDENCIA I LEFT JOIN MENSINCID M ON
                                   (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                    LEFT JOIN PRODUTO P ON
                                   (I.CDPRODUTO    = P.CDPRODUTO)
                  WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)      AND
                        (I.CDEMPRESA    = @P_EMPRESA)         AND
                        (I.CDTIPOOPER   = @P_TIPOOPER)        AND
                        (I.CDGRUPOFISC IS NULL)               AND
                        (I.CDIMPOSTO    = @V_CDIMPOSTO)       AND
                        (I.CDINSCESTA   = RTRIM(@P_INSCESTA)) AND
                        I.IDINCINTEREST = 'S'                 AND
                        (P.CDARVPROD    = @V_CDARVPROD);

               OPEN C_INCIDENCIA;
               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                      @V_INCID_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCID_CDDETALHEPROD,
                      @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)

                  FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                    @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                    @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                    @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
               END;
               CLOSE C_INCIDENCIA;
               DEALLOCATE C_INCIDENCIA;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_INCIDNULL CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                  FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                    ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                  WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)      AND
                        (I.CDEMPRESA    = @P_EMPRESA)         AND
                        (I.CDTIPOOPER   = @P_TIPOOPER)        AND
                        (I.CDGRUPOFISC IS NULL)               AND
                        (I.CDIMPOSTO    = @V_CDIMPOSTO)       AND
                        (I.CDINSCESTA   = RTRIM(@P_INSCESTA)) AND
                        I.IDINCINTEREST = 'S'                 AND
                        (CDPRODUTO IS NULL);

               OPEN C_INCIDNULL;

               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                      @V_INCIDN_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCIDN_CDDETALHEPROD,
                      @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)

                  FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                   @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                   @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
               END;
               CLOSE C_INCIDNULL;
               DEALLOCATE C_INCIDNULL;
            END;
            FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;
         END;
         CLOSE C_IMPOSTO;
         DEALLOCATE C_IMPOSTO;

      END;

      DECLARE C_IMPOSTO CURSOR FOR
         SELECT MAX(P.CDARVPROD) AS CDARVPROD, I.CDIMPOSTO
         FROM IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P ON
                        (I.CDPRODUTO    = P.CDPRODUTO)
         WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)                     AND
               (I.CDEMPRESA    = @P_EMPRESA)                        AND
               (I.CDTIPOOPER   = @P_TIPOOPER)                       AND
               (I.CDINSCESTA   = RTRIM(@P_INSCESTA))                AND
               (I.CDGRUPOFISC IS NULL)                              AND
               (I.CDIMPOSTO    = IP.CDIMPOSTO)                      AND
               (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1) AND
               I.IDINCINTEREST = 'N'                                AND
               NOT EXISTS (SELECT NRINCITEMP
                             FROM INCITEMP
                            WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                              AND CDIMPOTEMP = I.CDIMPOSTO)
         GROUP BY I.CDIMPOSTO;

      OPEN C_IMPOSTO;

      FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT @V_EXISTE = COUNT(*)
           FROM INCITEMP
          WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
            AND CDIMPOTEMP = @V_CDIMPOSTO;

         IF @V_EXISTE > 0 BEGIN
            DELETE FROM INCITEMP
             WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
               AND CDIMPOTEMP = @V_CDIMPOSTO;
         END;

         IF NOT (@V_CDARVPROD IS NULL) BEGIN

            DECLARE C_INCIDENCIA CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
               FROM INCIDENCIA I LEFT JOIN MENSINCID M ON
                                (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                 LEFT JOIN PRODUTO P ON
                                (I.CDPRODUTO    = P.CDPRODUTO)
               WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)      AND
                     (I.CDEMPRESA    = @P_EMPRESA)         AND
                     (I.CDTIPOOPER   = @P_TIPOOPER)        AND
                     (I.CDGRUPOFISC IS NULL)               AND
                     (I.CDIMPOSTO    = @V_CDIMPOSTO)       AND
                     (I.CDINSCESTA   = RTRIM(@P_INSCESTA)) AND
                     I.IDINCINTEREST = 'N'                 AND
                     (P.CDARVPROD    = @V_CDARVPROD);

            OPEN C_INCIDENCIA;
            FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                              @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                              @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                              @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                   @V_INCID_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCID_CDDETALHEPROD,
                   @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)

               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
            END;
            CLOSE C_INCIDENCIA;
            DEALLOCATE C_INCIDENCIA;
         END
         ELSE IF (@V_CDARVPROD IS NULL) BEGIN
            DECLARE C_INCIDNULL CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
               FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                 ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
               WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)      AND
                     (I.CDEMPRESA    = @P_EMPRESA)         AND
                     (I.CDTIPOOPER   = @P_TIPOOPER)        AND
                     (I.CDGRUPOFISC IS NULL)               AND
                     (I.CDIMPOSTO    = @V_CDIMPOSTO)       AND
                     (I.CDINSCESTA   = RTRIM(@P_INSCESTA)) AND
                     I.IDINCINTEREST = 'N'                 AND
                     (CDPRODUTO IS NULL);

            OPEN C_INCIDNULL;

            FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                             @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                             @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                             @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                   @V_INCIDN_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCIDN_CDDETALHEPROD,
                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)

               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
            END;
            CLOSE C_INCIDNULL;
            DEALLOCATE C_INCIDNULL;
         END;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;
      END;
      CLOSE C_IMPOSTO;
      DEALLOCATE C_IMPOSTO;
   END;

   /* Verificao das incidncias referente as filiais parametrizadas na tela Parmetros de Grupo Fiscal (Imposto/Filial) */
   DECLARE C_IMPFILI CURSOR FOR
      SELECT G.CDIMPOSTO, G.CDGRUPOFISC
        FROM GRUPOFISCIMPFIL G,
             (SELECT (CASE @P_ENTRSAIDIN WHEN 'E' THEN CDFILIRECE ELSE CDFILIEMIT END) AS CDFILIAL
                FROM NOTAFISCAL
               WHERE CDFILIAL = @P_FILIAL
                 AND NRLANCTONF = @P_LANCTONF
                 AND @P_IDSISTEMA IS NULL
                 AND @P_CDFILIRECE IS NULL
              UNION ALL
              SELECT CDFILIAL
                FROM PEDIDO
               WHERE CDFILIAL = SUBSTRING(@P_FILIAL,1,4)
                 AND NRPEDIDO = SUBSTRING(@P_FILIAL,5,10)
                 AND @P_IDSISTEMA = 'PED'
               UNION ALL
              SELECT CDFILIAL
                FROM FILIAL
               WHERE CDFILIAL = @P_CDFILIRECE) F
       WHERE G.CDFILIAL = F.CDFILIAL
         AND NOT G.CDGRUPOFISC IS NULL;

   OPEN C_IMPFILI;
   FETCH NEXT FROM C_IMPFILI INTO @V_IMPFILI_CDIMPOSTO, @V_IMPFILI_CDGRUPOFISC;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_NRINCITEMP = '';

      SELECT @V_NRINCITEMP = MAX(NRINCITEMP)
        FROM INCITEMP
       WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
         AND CDIMPOTEMP = @V_IMPFILI_CDIMPOSTO;

      IF NOT @V_NRINCITEMP IS NULL BEGIN
         DELETE FROM INCITEMP
          WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
            AND CDIMPOTEMP = @V_IMPFILI_CDIMPOSTO;
      END;

      /* Operao Interestadual */
      IF @P_IDINCINTEREST = 'S' BEGIN

         DECLARE C_IMPOSTO CURSOR FOR
            SELECT MAX(P.CDARVPROD) AS CDARVPROD
              FROM IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P ON (I.CDPRODUTO = P.CDPRODUTO)
             WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
               AND (I.CDEMPRESA = @P_EMPRESA)
               AND (I.CDTIPOOPER = @P_TIPOOPER)
               AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
               AND ((I.CDGRUPOFISC = @V_IMPFILI_CDGRUPOFISC) AND (IP.IDGRUPFISSRV <> 'S'))
               AND (I.CDIMPOSTO = @V_IMPFILI_CDIMPOSTO)
               AND (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1)
               AND I.IDINCINTEREST = 'S'
               AND (I.CDIMPOSTO = IP.CDIMPOSTO);

         OPEN C_IMPOSTO;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            IF NOT (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_INCIDENCIA CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                      LEFT JOIN PRODUTO P ON (I.CDPRODUTO = P.CDPRODUTO)
                   WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                     AND (I.CDEMPRESA = @P_EMPRESA)
                     AND (I.CDTIPOOPER = @P_TIPOOPER)
                     AND (I.CDGRUPOFISC = @V_IMPFILI_CDGRUPOFISC)
                     AND (I.CDIMPOSTO = @V_IMPFILI_CDIMPOSTO)
                     AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
                     AND I.IDINCINTEREST = 'S'
                     AND (P.CDARVPROD = @V_CDARVPROD);

               OPEN C_INCIDENCIA;
               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                      @V_INCID_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCID_CDDETALHEPROD,
                      @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                    @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                    @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                    @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
               END;
               CLOSE C_INCIDENCIA;
               DEALLOCATE C_INCIDENCIA;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN

               DECLARE C_INCIDNULL CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                   WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                     AND (I.CDEMPRESA = @P_EMPRESA)
                     AND (I.CDTIPOOPER = @P_TIPOOPER)
                     AND (I.CDGRUPOFISC = @V_IMPFILI_CDGRUPOFISC)
                     AND (I.CDIMPOSTO = @V_IMPFILI_CDIMPOSTO)
                     AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
                     AND I.IDINCINTEREST = 'S'
                     AND (CDPRODUTO IS NULL);

               OPEN C_INCIDNULL;
               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                      @V_INCIDN_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCIDN_CDDETALHEPROD,
                      @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                   @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                   @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
               END;
               CLOSE C_INCIDNULL;
               DEALLOCATE C_INCIDNULL;
            END;
            FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;
         END;
         CLOSE C_IMPOSTO;
         DEALLOCATE C_IMPOSTO;
      END;

      DECLARE C_IMPOSTO CURSOR FOR
         SELECT MAX(P.CDARVPROD) AS CDARVPROD
           FROM IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P ON (I.CDPRODUTO = P.CDPRODUTO)
          WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
            AND (I.CDEMPRESA = @P_EMPRESA)
            AND (I.CDTIPOOPER = @P_TIPOOPER)
            AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
            AND ((I.CDGRUPOFISC = @V_IMPFILI_CDGRUPOFISC) AND (IP.IDGRUPFISSRV <> 'S'))
            AND (I.CDIMPOSTO = @V_IMPFILI_CDIMPOSTO)
            AND (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1)
            AND I.IDINCINTEREST = 'N'
            AND NOT EXISTS (SELECT NRINCITEMP
                             FROM INCITEMP
                            WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                              AND CDIMPOTEMP = I.CDIMPOSTO)
            AND (I.CDIMPOSTO = IP.CDIMPOSTO);

      OPEN C_IMPOSTO;
      FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF NOT (@V_CDARVPROD IS NULL) BEGIN
            DECLARE C_INCIDENCIA CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                   LEFT JOIN PRODUTO P ON (I.CDPRODUTO = P.CDPRODUTO)
                WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                  AND (I.CDEMPRESA = @P_EMPRESA)
                  AND (I.CDTIPOOPER = @P_TIPOOPER)
                  AND (I.CDGRUPOFISC = @V_IMPFILI_CDGRUPOFISC)
                  AND (I.CDIMPOSTO = @V_IMPFILI_CDIMPOSTO)
                  AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
                  AND I.IDINCINTEREST = 'N'
                  AND (P.CDARVPROD = @V_CDARVPROD);

            OPEN C_INCIDENCIA;
            FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                              @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                              @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                              @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                   @V_INCID_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCID_CDDETALHEPROD,
                   @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
            END;
            CLOSE C_INCIDENCIA;
            DEALLOCATE C_INCIDENCIA;
         END
         ELSE IF (@V_CDARVPROD IS NULL) BEGIN

            DECLARE C_INCIDNULL CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                  AND (I.CDEMPRESA = @P_EMPRESA)
                  AND (I.CDTIPOOPER = @P_TIPOOPER)
                  AND (I.CDGRUPOFISC = @V_IMPFILI_CDGRUPOFISC)
                  AND (I.CDIMPOSTO = @V_IMPFILI_CDIMPOSTO)
                  AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
                  AND I.IDINCINTEREST = 'N'
                  AND (CDPRODUTO IS NULL);

            OPEN C_INCIDNULL;
            FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                             @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                             @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                             @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                   @V_INCIDN_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCIDN_CDDETALHEPROD,
                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
            END;
            CLOSE C_INCIDNULL;
            DEALLOCATE C_INCIDNULL;
         END;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;
      END;
      CLOSE C_IMPOSTO;
      DEALLOCATE C_IMPOSTO;

      FETCH NEXT FROM C_IMPFILI INTO @V_IMPFILI_CDIMPOSTO, @V_IMPFILI_CDGRUPOFISC;
   END;
   CLOSE C_IMPFILI;
   DEALLOCATE C_IMPFILI;

   /* Verificao das incidncias referente aos Fornecedores/Clientes parametrizadas na tela Parmetros de Grupo Fiscal (Imposto/Inscrio Estadual) */
   /*Por Fornecedor*/
   DECLARE C_IMPINSCESTAFO CURSOR FOR
      SELECT G.CDIMPOSTO, G.CDGRUPOFISC
        FROM GRFISIMPIEFORN G,
             (SELECT CDFORNECED
                FROM NOTAFISCAL
               WHERE CDFILIAL = @P_FILIAL
                 AND NRLANCTONF = @P_LANCTONF
                 AND @P_CDFORNECED IS NULL
               UNION ALL
              SELECT CDFORNECED
                FROM FORNECEDOR
               WHERE CDFORNECED = @P_CDFORNECED) N
       WHERE G.CDFORNECED = N.CDFORNECED
         AND G.CDEMPRESA = @P_EMPRESA
         AND G.CDINSCESTA = @P_INSCESTA
         AND NOT G.CDGRUPOFISC IS NULL;

   OPEN C_IMPINSCESTAFO;
   FETCH NEXT FROM C_IMPINSCESTAFO INTO @V_IMPINSCESTAFO_CDIMPOSTO, @V_IMPINSCESTAFO_CDGRUPOFISC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SET @V_NRINCITEMP = '';

      SELECT @V_NRINCITEMP = MAX(NRINCITEMP)
        FROM INCITEMP
       WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
         AND CDIMPOTEMP = @V_IMPINSCESTAFO_CDIMPOSTO;

      IF NOT @V_NRINCITEMP IS NULL BEGIN
         DELETE FROM INCITEMP
          WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
            AND CDIMPOTEMP = @V_IMPINSCESTAFO_CDIMPOSTO;
      END;

      /* Operao Interestadual */
      IF @P_IDINCINTEREST = 'S' BEGIN

         DECLARE C_IMPOSTO CURSOR FOR
            SELECT MAX(P.CDARVPROD) AS CDARVPROD
              FROM IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P ON (I.CDPRODUTO = P.CDPRODUTO)
             WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
               AND (I.CDEMPRESA = @P_EMPRESA)
               AND (I.CDTIPOOPER = @P_TIPOOPER)
               AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
               AND ((I.CDGRUPOFISC = @V_IMPINSCESTAFO_CDGRUPOFISC) AND (IP.IDGRUPFISSRV <> 'S'))
               AND (I.CDIMPOSTO = @V_IMPINSCESTAFO_CDIMPOSTO)
               AND (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1)
               AND I.IDINCINTEREST = 'S'
               AND (I.CDIMPOSTO = IP.CDIMPOSTO);

         OPEN C_IMPOSTO;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            IF NOT (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_INCIDENCIA CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                      LEFT JOIN PRODUTO P ON (I.CDPRODUTO = P.CDPRODUTO)
                   WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                     AND (I.CDEMPRESA = @P_EMPRESA)
                     AND (I.CDTIPOOPER = @P_TIPOOPER)
                     AND (I.CDGRUPOFISC = @V_IMPINSCESTAFO_CDGRUPOFISC)
                     AND (I.CDIMPOSTO = @V_IMPINSCESTAFO_CDIMPOSTO)
                     AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
                     AND I.IDINCINTEREST = 'S'
                     AND (P.CDARVPROD = @V_CDARVPROD);

               OPEN C_INCIDENCIA;
               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                      @V_INCID_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCID_CDDETALHEPROD,
                      @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                    @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                    @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                    @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
               END;
               CLOSE C_INCIDENCIA;
               DEALLOCATE C_INCIDENCIA;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN

               DECLARE C_INCIDNULL CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                   WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                     AND (I.CDEMPRESA = @P_EMPRESA)
                     AND (I.CDTIPOOPER = @P_TIPOOPER)
                     AND (I.CDGRUPOFISC = @V_IMPINSCESTAFO_CDGRUPOFISC)
                     AND (I.CDIMPOSTO = @V_IMPINSCESTAFO_CDIMPOSTO)
                     AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
                     AND I.IDINCINTEREST = 'S'
                     AND (CDPRODUTO IS NULL);

               OPEN C_INCIDNULL;
               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                      @V_INCIDN_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCIDN_CDDETALHEPROD,
                      @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                   @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                   @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
               END;
               CLOSE C_INCIDNULL;
               DEALLOCATE C_INCIDNULL;
            END;
            FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;
         END;
         CLOSE C_IMPOSTO;
         DEALLOCATE C_IMPOSTO;
      END;

      DECLARE C_IMPOSTO CURSOR FOR
         SELECT MAX(P.CDARVPROD) AS CDARVPROD
           FROM IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P ON (I.CDPRODUTO = P.CDPRODUTO)
          WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
            AND (I.CDEMPRESA = @P_EMPRESA)
            AND (I.CDTIPOOPER = @P_TIPOOPER)
            AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
            AND ((I.CDGRUPOFISC = @V_IMPINSCESTAFO_CDGRUPOFISC) AND (IP.IDGRUPFISSRV <> 'S'))
            AND (I.CDIMPOSTO = @V_IMPINSCESTAFO_CDIMPOSTO)
            AND (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1)
            AND I.IDINCINTEREST = 'N'
            AND NOT EXISTS (SELECT NRINCITEMP
                              FROM INCITEMP
                             WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                               AND CDIMPOTEMP = I.CDIMPOSTO)
            AND (I.CDIMPOSTO = IP.CDIMPOSTO);

      OPEN C_IMPOSTO;
      FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF NOT (@V_CDARVPROD IS NULL) BEGIN
            DECLARE C_INCIDENCIA CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                   LEFT JOIN PRODUTO P ON (I.CDPRODUTO = P.CDPRODUTO)
                WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                  AND (I.CDEMPRESA = @P_EMPRESA)
                  AND (I.CDTIPOOPER = @P_TIPOOPER)
                  AND (I.CDGRUPOFISC = @V_IMPINSCESTAFO_CDGRUPOFISC)
                  AND (I.CDIMPOSTO = @V_IMPINSCESTAFO_CDIMPOSTO)
                  AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
                  AND I.IDINCINTEREST = 'N'
                  AND (P.CDARVPROD = @V_CDARVPROD);

            OPEN C_INCIDENCIA;
            FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                              @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                              @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                              @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                   @V_INCID_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCID_CDDETALHEPROD,
                   @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
            END;
            CLOSE C_INCIDENCIA;
            DEALLOCATE C_INCIDENCIA;
         END
         ELSE IF (@V_CDARVPROD IS NULL) BEGIN

            DECLARE C_INCIDNULL CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                  AND (I.CDEMPRESA = @P_EMPRESA)
                  AND (I.CDTIPOOPER = @P_TIPOOPER)
                  AND (I.CDGRUPOFISC = @V_IMPINSCESTAFO_CDGRUPOFISC)
                  AND (I.CDIMPOSTO = @V_IMPINSCESTAFO_CDIMPOSTO)
                  AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
                  AND I.IDINCINTEREST = 'N'
                  AND (CDPRODUTO IS NULL);

            OPEN C_INCIDNULL;
            FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                             @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                             @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                             @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                   @V_INCIDN_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCIDN_CDDETALHEPROD,
                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
            END;
            CLOSE C_INCIDNULL;
            DEALLOCATE C_INCIDNULL;
         END;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;
      END;
      CLOSE C_IMPOSTO;
      DEALLOCATE C_IMPOSTO;

      FETCH NEXT FROM C_IMPINSCESTAFO INTO @V_IMPINSCESTAFO_CDIMPOSTO, @V_IMPINSCESTAFO_CDGRUPOFISC;
   END;
   CLOSE C_IMPINSCESTAFO;
   DEALLOCATE C_IMPINSCESTAFO;

   /* Verificao das incidncias referente as filiais parametrizadas na tela Parmetros de Grupo Fiscal (Imposto/Inscrio Estadual) */
   /* Por Cliente */
   DECLARE C_IMPINSCESTACL CURSOR FOR
      SELECT G.CDIMPOSTO, G.CDGRUPOFISC
        FROM GRFISIMPIECLIE G,
             (SELECT CDCLIENTE
                FROM NOTAFISCAL
               WHERE CDFILIAL = @P_FILIAL
                 AND NRLANCTONF = @P_LANCTONF
                 AND @P_CDCLIENTE IS NULL
               UNION ALL
              SELECT CDCLIENTE
                FROM CLIENTE
               WHERE CDCLIENTE = @P_CDCLIENTE) N

       WHERE G.CDCLIENTE = N.CDCLIENTE
         AND G.CDEMPRESA = @P_EMPRESA
         AND G.CDINSCESTA = @P_INSCESTA
         AND NOT G.CDGRUPOFISC IS NULL;

   OPEN C_IMPINSCESTACL;
   FETCH NEXT FROM C_IMPINSCESTACL INTO @V_IMPINSCESTACL_CDIMPOSTO, @V_IMPINSCESTACL_CDGRUPOFISC;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_NRINCITEMP = '';

      SELECT @V_NRINCITEMP = MAX(NRINCITEMP)
        FROM INCITEMP
       WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
         AND CDIMPOTEMP = @V_IMPINSCESTACL_CDIMPOSTO;

      IF NOT @V_NRINCITEMP IS NULL BEGIN
         DELETE FROM INCITEMP
          WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
            AND CDIMPOTEMP = @V_IMPINSCESTACL_CDIMPOSTO;
      END;

      /* Operao Interestadual */
      IF @P_IDINCINTEREST = 'S' BEGIN

         DECLARE C_IMPOSTO CURSOR FOR
            SELECT MAX(P.CDARVPROD) AS CDARVPROD
              FROM IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P ON (I.CDPRODUTO = P.CDPRODUTO)
             WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
               AND (I.CDEMPRESA = @P_EMPRESA)
               AND (I.CDTIPOOPER = @P_TIPOOPER)
               AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
               AND ((I.CDGRUPOFISC = @V_IMPINSCESTACL_CDGRUPOFISC) AND (IP.IDGRUPFISSRV <> 'S'))
               AND (I.CDIMPOSTO = @V_IMPINSCESTACL_CDIMPOSTO)
               AND (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1)
               AND I.IDINCINTEREST = 'S'
               AND (I.CDIMPOSTO = IP.CDIMPOSTO);

         OPEN C_IMPOSTO;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            IF NOT (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_INCIDENCIA CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                      LEFT JOIN PRODUTO P ON (I.CDPRODUTO = P.CDPRODUTO)
                   WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                     AND (I.CDEMPRESA = @P_EMPRESA)
                     AND (I.CDTIPOOPER = @P_TIPOOPER)
                     AND (I.CDGRUPOFISC = @V_IMPINSCESTACL_CDGRUPOFISC)
                     AND (I.CDIMPOSTO = @V_IMPINSCESTACL_CDIMPOSTO)
                     AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
                     AND I.IDINCINTEREST = 'S'
                     AND (P.CDARVPROD = @V_CDARVPROD);

               OPEN C_INCIDENCIA;
               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                      @V_INCID_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCID_CDDETALHEPROD,
                      @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                    @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                    @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                    @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
               END;
               CLOSE C_INCIDENCIA;
               DEALLOCATE C_INCIDENCIA;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN

               DECLARE C_INCIDNULL CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                   WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                     AND (I.CDEMPRESA = @P_EMPRESA)
                     AND (I.CDTIPOOPER = @P_TIPOOPER)
                     AND (I.CDGRUPOFISC = @V_IMPINSCESTACL_CDGRUPOFISC)
                     AND (I.CDIMPOSTO = @V_IMPINSCESTACL_CDIMPOSTO)
                     AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
                     AND I.IDINCINTEREST = 'S'
                     AND (CDPRODUTO IS NULL);

               OPEN C_INCIDNULL;
               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                      @V_INCIDN_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCIDN_CDDETALHEPROD,
                      @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                   @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                   @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
               END;
               CLOSE C_INCIDNULL;
               DEALLOCATE C_INCIDNULL;
            END;
            FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;
         END;
         CLOSE C_IMPOSTO;
         DEALLOCATE C_IMPOSTO;
      END;

      DECLARE C_IMPOSTO CURSOR FOR
         SELECT MAX(P.CDARVPROD) AS CDARVPROD
           FROM IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P ON (I.CDPRODUTO = P.CDPRODUTO)
          WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
            AND (I.CDEMPRESA = @P_EMPRESA)
            AND (I.CDTIPOOPER = @P_TIPOOPER)
            AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
            AND ((I.CDGRUPOFISC = @V_IMPINSCESTACL_CDGRUPOFISC) AND (IP.IDGRUPFISSRV <> 'S'))
            AND (I.CDIMPOSTO = @V_IMPINSCESTACL_CDIMPOSTO)
            AND (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1)
            AND I.IDINCINTEREST = 'N'
            AND NOT EXISTS (SELECT NRINCITEMP
                              FROM INCITEMP
                             WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                               AND CDIMPOTEMP = I.CDIMPOSTO)
            AND (I.CDIMPOSTO = IP.CDIMPOSTO);

      OPEN C_IMPOSTO;
      FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF NOT (@V_CDARVPROD IS NULL) BEGIN
            DECLARE C_INCIDENCIA CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                   LEFT JOIN PRODUTO P ON (I.CDPRODUTO = P.CDPRODUTO)
                WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                  AND (I.CDEMPRESA = @P_EMPRESA)
                  AND (I.CDTIPOOPER = @P_TIPOOPER)
                  AND (I.CDGRUPOFISC = @V_IMPINSCESTACL_CDGRUPOFISC)
                  AND (I.CDIMPOSTO = @V_IMPINSCESTACL_CDIMPOSTO)
                  AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
                  AND I.IDINCINTEREST = 'N'
                  AND (P.CDARVPROD = @V_CDARVPROD);

            OPEN C_INCIDENCIA;
            FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                              @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                              @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                              @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                   @V_INCID_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCID_CDDETALHEPROD,
                   @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
            END;
            CLOSE C_INCIDENCIA;
            DEALLOCATE C_INCIDENCIA;
         END
         ELSE IF (@V_CDARVPROD IS NULL) BEGIN

            DECLARE C_INCIDNULL CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                  AND (I.CDEMPRESA = @P_EMPRESA)
                  AND (I.CDTIPOOPER = @P_TIPOOPER)
                  AND (I.CDGRUPOFISC = @V_IMPINSCESTACL_CDGRUPOFISC)
                  AND (I.CDIMPOSTO = @V_IMPINSCESTACL_CDIMPOSTO)
                  AND (I.CDINSCESTA = RTRIM(@P_INSCESTA))
                  AND I.IDINCINTEREST = 'N'
                  AND (CDPRODUTO IS NULL);

            OPEN C_INCIDNULL;
            FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                             @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                             @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                             @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                   @V_INCIDN_CDFISCAL, @V_DSMENSINCID, @P_INSCESTA, @V_INCIDN_CDDETALHEPROD,
                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
            END;
            CLOSE C_INCIDNULL;
            DEALLOCATE C_INCIDNULL;
         END;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;
      END;
      CLOSE C_IMPOSTO;
      DEALLOCATE C_IMPOSTO;


      FETCH NEXT FROM C_IMPINSCESTACL INTO @V_IMPINSCESTACL_CDIMPOSTO, @V_IMPINSCESTACL_CDGRUPOFISC;
   END;
   CLOSE C_IMPINSCESTACL;
   DEALLOCATE C_IMPINSCESTACL;

   /*------------------------IMPOSTOS FEDERAIS--------------------------------------*/
   IF (@P_CDGRUPOFISC IS NOT NULL)  BEGIN

      /* Operao Interestadual */
      IF @P_IDINCINTEREST = 'S' BEGIN

         DECLARE C_IMPOSTO CURSOR FOR
            SELECT MAX(P.CDARVPROD) AS CDARVPROD, I.CDIMPOSTO
              FROM IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P
                                            ON (I.CDPRODUTO    = P.CDPRODUTO)
             WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
               AND (I.CDEMPRESA    = @P_EMPRESA)
               AND (I.CDTIPOOPER   = @P_TIPOOPER)
               AND (I.CDINSCESTA   IS NULL)
               AND ((I.CDGRUPOFISC  = @P_CDGRUPOFISC) AND (IP.IDGRUPFISSRV <> 'S'))
               AND (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1)
               AND (I.CDIMPOSTO = IP.CDIMPOSTO)
               AND I.IDINCINTEREST = 'S'
            GROUP BY I.CDIMPOSTO;
         OPEN C_IMPOSTO;

         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF NOT (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_INCIDENCIA CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID,
                         ISNULL(I.IDINCINTEREST,'N') IDINCINTEREST, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                      ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                      LEFT JOIN PRODUTO P
                                      ON (I.CDPRODUTO    = P.CDPRODUTO)
                   WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                     AND (I.CDEMPRESA    = @P_EMPRESA)
                     AND (I.CDTIPOOPER   = @P_TIPOOPER)
                     AND (I.CDGRUPOFISC  = @P_CDGRUPOFISC)
                     AND (I.CDIMPOSTO    = @V_CDIMPOSTO)
                     AND (I.CDINSCESTA   IS NULL)
                     AND I.IDINCINTEREST = 'S'
                     AND (P.CDARVPROD    = @V_CDARVPROD);
               OPEN C_INCIDENCIA;
               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_IDINCINTEREST, @V_INCID_CDMENSAGEM,
                                                 @V_INCID_CDDETALHEPROD, @V_INCID_CDENQLEGALIPI,
                                                 @V_INCID_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_COUNT = COUNT(*)
                    FROM INCITEMP
                   WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                     AND CDIMPOTEMP = @V_INCID_CDIMPOSTO;

                  IF @V_COUNT = 0 BEGIN
                     SELECT @V_COUNTMENS = COUNT(*)
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';

                     IF @V_COUNTMENS > 0 BEGIN
                        SET @V_DSMENSINCID = NULL;
                     END
                     ELSE BEGIN
                        SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
                     END;

                     INSERT INTO INCITEMP
                        (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                         CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                         CDENQLEGALIPI, CDCEST)
                     VALUES
                        (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                         @V_INCID_CDFISCAL, @V_DSMENSINCID, NULL, @V_INCID_CDDETALHEPROD,
                         @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

                     SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);
                  END;
                  FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                    @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                    @V_INCID_IDINCINTEREST, @V_INCID_CDMENSAGEM,
                                                    @V_INCID_CDDETALHEPROD, @V_INCID_CDENQLEGALIPI,
                                                    @V_INCID_CDCEST;
               END;
               CLOSE C_INCIDENCIA;
               DEALLOCATE C_INCIDENCIA;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_INCIDNULL CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID,
                         ISNULL(I.IDINCINTEREST,'N') IDINCINTEREST, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                      ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                   WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                     AND (I.CDEMPRESA    = @P_EMPRESA)
                     AND (I.CDTIPOOPER   = @P_TIPOOPER)
                     AND (I.CDGRUPOFISC  = @P_CDGRUPOFISC)
                     AND (I.CDIMPOSTO    = @V_CDIMPOSTO)
                     AND (I.CDINSCESTA   IS NULL)
                     AND I.IDINCINTEREST = 'S'
                     AND (CDPRODUTO IS NULL);
               OPEN C_INCIDNULL;

               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_IDINCINTEREST, @V_INCIDN_CDMENSAGEM,
                                                @V_INCIDN_CDDETALHEPROD, @V_INCIDN_CDENQLEGALIPI,
                                                @V_INCIDN_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_COUNT = COUNT(*)
                    FROM INCITEMP
                   WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                     AND CDIMPOTEMP = @V_INCIDN_CDIMPOSTO;

                  IF @V_COUNT = 0 BEGIN

                     SELECT @V_COUNTMENS = COUNT(*)
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';

                      IF @V_COUNTMENS > 0 BEGIN
                         SET @V_DSMENSINCID = NULL;
                      END
                      ELSE BEGIN
                         SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
                      END;

                      INSERT INTO INCITEMP
                         (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                          CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                          CDENQLEGALIPI, CDCEST)
                      VALUES
                         (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA,@V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                          @V_INCIDN_CDFISCAL, @V_DSMENSINCID, NULL, @V_INCIDN_CDDETALHEPROD,
                          @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

                      SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);
                  END;
                  FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                   @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                   @V_INCIDN_IDINCINTEREST, @V_INCIDN_CDMENSAGEM,
                                                   @V_INCIDN_CDDETALHEPROD, @V_INCIDN_CDENQLEGALIPI,
                                                   @V_INCIDN_CDCEST;
               END;
               CLOSE C_INCIDNULL;
               DEALLOCATE C_INCIDNULL;
            END;
            FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;
         END;
         CLOSE C_IMPOSTO;
         DEALLOCATE C_IMPOSTO;
      END;

      DECLARE C_IMPOSTO CURSOR FOR
         SELECT MAX(P.CDARVPROD) AS CDARVPROD, I.CDIMPOSTO
           FROM IMPOSTO IP, INCIDENCIA I LEFT JOIN PRODUTO P
                                         ON (I.CDPRODUTO    = P.CDPRODUTO)
          WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
            AND (I.CDEMPRESA    = @P_EMPRESA)
            AND (I.CDTIPOOPER   = @P_TIPOOPER)
            AND (I.CDINSCESTA   IS NULL)
            AND ((I.CDGRUPOFISC  = @P_CDGRUPOFISC) AND (IP.IDGRUPFISSRV <> 'S'))
            AND (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')),ISNULL(@P_PRODUTO,'_')) = 1)
            AND (I.CDIMPOSTO = IP.CDIMPOSTO)
            AND I.IDINCINTEREST = 'N'
         GROUP BY I.CDIMPOSTO;
      OPEN C_IMPOSTO;

      FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF NOT (@V_CDARVPROD IS NULL) BEGIN
            DECLARE C_INCIDENCIA CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID,
                      ISNULL(I.IDINCINTEREST,'N') IDINCINTEREST, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                   ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                   LEFT JOIN PRODUTO P
                                   ON (I.CDPRODUTO    = P.CDPRODUTO)
                WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                  AND (I.CDEMPRESA    = @P_EMPRESA)
                  AND (I.CDTIPOOPER   = @P_TIPOOPER)
                  AND (I.CDGRUPOFISC  = @P_CDGRUPOFISC)
                  AND (I.CDIMPOSTO    = @V_CDIMPOSTO)
                  AND (I.CDINSCESTA   IS NULL)
                  AND I.IDINCINTEREST = 'N'
                  AND (P.CDARVPROD    = @V_CDARVPROD);
            OPEN C_INCIDENCIA;
            FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                              @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                              @V_INCID_IDINCINTEREST, @V_INCID_CDMENSAGEM,
                                              @V_INCID_CDDETALHEPROD, @V_INCID_CDENQLEGALIPI,
                                              @V_INCID_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SELECT @V_COUNT = COUNT(*)
                 FROM INCITEMP
                WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                  AND CDIMPOTEMP = @V_INCID_CDIMPOSTO;

               IF @V_COUNT = 0 BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                      @V_INCID_CDFISCAL, @V_DSMENSINCID, NULL, @V_INCID_CDDETALHEPROD,
                      @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);
               END;
               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_IDINCINTEREST, @V_INCID_CDMENSAGEM,
                                                 @V_INCID_CDDETALHEPROD, @V_INCID_CDENQLEGALIPI,
                                                 @V_INCID_CDCEST;
            END;
            CLOSE C_INCIDENCIA;
            DEALLOCATE C_INCIDENCIA;
         END
         ELSE IF (@V_CDARVPROD IS NULL) BEGIN
            DECLARE C_INCIDNULL CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID,
                      ISNULL(I.IDINCINTEREST,'N') IDINCINTEREST, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                   ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                  AND (I.CDEMPRESA    = @P_EMPRESA)
                  AND (I.CDTIPOOPER   = @P_TIPOOPER)
                  AND (I.CDGRUPOFISC  = @P_CDGRUPOFISC)
                  AND (I.CDIMPOSTO    = @V_CDIMPOSTO)
                  AND (I.CDINSCESTA   IS NULL)
                  AND I.IDINCINTEREST = 'N'
                  AND (CDPRODUTO IS NULL);
            OPEN C_INCIDNULL;

            FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                             @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                             @V_INCIDN_IDINCINTEREST, @V_INCIDN_CDMENSAGEM,
                                             @V_INCIDN_CDDETALHEPROD, @V_INCIDN_CDENQLEGALIPI,
                                             @V_INCIDN_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SELECT @V_COUNT = COUNT(*)
                 FROM INCITEMP
                WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                  AND CDIMPOTEMP = @V_INCIDN_CDIMPOSTO;

               IF @V_COUNT = 0 BEGIN

                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                   IF @V_COUNTMENS > 0 BEGIN
                      SET @V_DSMENSINCID = NULL;
                   END
                   ELSE BEGIN
                      SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
                   END;

                   INSERT INTO INCITEMP
                      (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                       CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                       CDENQLEGALIPI, CDCEST)
                   VALUES
                      (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA,@V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                       @V_INCIDN_CDFISCAL, @V_DSMENSINCID, NULL, @V_INCIDN_CDDETALHEPROD,
                       @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

                   SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);
               END;
               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_IDINCINTEREST, @V_INCIDN_CDMENSAGEM,
                                                @V_INCIDN_CDDETALHEPROD, @V_INCIDN_CDENQLEGALIPI,
                                                @V_INCIDN_CDCEST;
            END;
            CLOSE C_INCIDNULL;
            DEALLOCATE C_INCIDNULL;
         END;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;
      END;
      CLOSE C_IMPOSTO;
      DEALLOCATE C_IMPOSTO;
   END
   ELSE BEGIN
      /* Operao Interestadual */
      IF @P_IDINCINTEREST = 'S' BEGIN

         DECLARE C_IMPOSTO CURSOR FOR
            SELECT MAX(P.CDARVPROD) AS CDARVPROD, CDIMPOSTO
              FROM INCIDENCIA I LEFT JOIN PRODUTO P
                                ON (I.CDPRODUTO    = P.CDPRODUTO)
             WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
               AND (I.CDEMPRESA    = @P_EMPRESA)
               AND (I.CDTIPOOPER   = @P_TIPOOPER)
               AND (I.CDINSCESTA   IS NULL)
               AND (I.CDGRUPOFISC IS NULL)
               AND (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')), ISNULL(@P_PRODUTO,'_')) = 1)
               AND I.IDINCINTEREST = 'S'
            GROUP BY CDIMPOSTO;
         OPEN C_IMPOSTO;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF NOT (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_INCIDENCIA CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID,
                         ISNULL(I.IDINCINTEREST, 'N') IDINCINTEREST, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                      ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                      LEFT JOIN PRODUTO P
                                      ON (I.CDPRODUTO    = P.CDPRODUTO)
                   WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                     AND (I.CDEMPRESA    = @P_EMPRESA)
                     AND (I.CDTIPOOPER   = @P_TIPOOPER)
                     AND (I.CDIMPOSTO    = @V_CDIMPOSTO)
                     AND (I.CDINSCESTA   IS NULL)
                     AND (I.CDGRUPOFISC IS NULL)
                     AND I.IDINCINTEREST = 'S'
                     AND (P.CDARVPROD    = @V_CDARVPROD);
               OPEN C_INCIDENCIA;

               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_IDINCINTEREST, @V_INCID_CDMENSAGEM,
                                                 @V_INCID_CDDETALHEPROD, @V_INCID_CDENQLEGALIPI,
                                                 @V_INCID_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNT = COUNT(*)
                    FROM INCITEMP
                   WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                     AND CDIMPOTEMP = @V_INCID_CDIMPOSTO;

                  IF @V_COUNT = 0 BEGIN
                     SELECT @V_COUNTMENS = COUNT(*)
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';

                     IF @V_COUNTMENS > 0 BEGIN
                        SET @V_DSMENSINCID = NULL;
                     END
                     ELSE BEGIN
                        SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
                     END;

                     INSERT INTO INCITEMP
                        (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                         CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                         CDENQLEGALIPI, CDCEST)
                     VALUES
                        (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                         @V_INCID_CDFISCAL, @V_DSMENSINCID, NULL, @V_INCID_CDDETALHEPROD,
                         @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

                     SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);
                  END;
                  FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                    @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                    @V_INCID_IDINCINTEREST, @V_INCID_CDMENSAGEM,
                                                    @V_INCID_CDDETALHEPROD, @V_INCID_CDENQLEGALIPI,
                                                    @V_INCID_CDCEST;
               END;
               CLOSE C_INCIDENCIA;
               DEALLOCATE C_INCIDENCIA;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_INCIDNULL CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID,
                         ISNULL(I.IDINCINTEREST, 'N') IDINCINTEREST, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI, 
                         I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                      ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                   WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                     AND (I.CDEMPRESA    = @P_EMPRESA)
                     AND (I.CDTIPOOPER   = @P_TIPOOPER)
                     AND (I.CDIMPOSTO    = @V_CDIMPOSTO)
                     AND (I.CDINSCESTA   IS NULL)
                     AND (I.CDGRUPOFISC  IS NULL)
                     AND I.IDINCINTEREST = 'S'
                     AND (CDPRODUTO IS NULL);
               OPEN C_INCIDNULL;

               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_IDINCINTEREST, @V_INCIDN_CDMENSAGEM,
                                                @V_INCIDN_CDDETALHEPROD, @V_INCIDN_CDENQLEGALIPI,
                                                @V_INCIDN_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_COUNT = COUNT(*)
                    FROM INCITEMP
                   WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                     AND CDIMPOTEMP = @V_INCIDN_CDIMPOSTO;

                  IF @V_COUNT = 0 BEGIN
                     SELECT @V_COUNTMENS = COUNT(*)
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';

                     IF @V_COUNTMENS > 0 BEGIN
                        SET @V_DSMENSINCID = NULL;
                     END
                     ELSE BEGIN
                        SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
                     END;

                     INSERT INTO INCITEMP
                        (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                         CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                         CDENQLEGALIPI, CDCEST)
                     VALUES(@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                            @V_INCIDN_CDFISCAL, @V_DSMENSINCID, NULL, @V_INCIDN_CDDETALHEPROD,
                            @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

                     SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);
                  END;
                  FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                   @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                   @V_INCIDN_IDINCINTEREST, @V_INCIDN_CDMENSAGEM,
                                                   @V_INCIDN_CDDETALHEPROD, @V_INCIDN_CDENQLEGALIPI,
                                                   @V_INCIDN_CDCEST;
               END;
               CLOSE C_INCIDNULL;
               DEALLOCATE C_INCIDNULL;
            END;
            FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;
         END;
         CLOSE C_IMPOSTO;
         DEALLOCATE C_IMPOSTO;
      END;

      DECLARE C_IMPOSTO CURSOR FOR
         SELECT MAX(P.CDARVPROD) AS CDARVPROD, CDIMPOSTO
           FROM INCIDENCIA I LEFT JOIN PRODUTO P
                             ON (I.CDPRODUTO    = P.CDPRODUTO)
          WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
            AND (I.CDEMPRESA    = @P_EMPRESA)
            AND (I.CDTIPOOPER   = @P_TIPOOPER)
            AND (I.CDINSCESTA   IS NULL)
            AND (I.CDGRUPOFISC IS NULL)
            AND (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')), ISNULL(@P_PRODUTO,'_')) = 1)
            AND I.IDINCINTEREST = 'N'
         GROUP BY CDIMPOSTO;
      OPEN C_IMPOSTO;
      FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF NOT (@V_CDARVPROD IS NULL) BEGIN
            DECLARE C_INCIDENCIA CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID,
                      ISNULL(I.IDINCINTEREST, 'N') IDINCINTEREST, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                   ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                   LEFT JOIN PRODUTO P
                                   ON (I.CDPRODUTO    = P.CDPRODUTO)
                WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                  AND (I.CDEMPRESA    = @P_EMPRESA)
                  AND (I.CDTIPOOPER   = @P_TIPOOPER)
                  AND (I.CDIMPOSTO    = @V_CDIMPOSTO)
                  AND (I.CDINSCESTA   IS NULL)
                  AND (I.CDGRUPOFISC IS NULL)
                  AND I.IDINCINTEREST = 'N'
                  AND (P.CDARVPROD    = @V_CDARVPROD);
            OPEN C_INCIDENCIA;

            FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                              @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                              @V_INCID_IDINCINTEREST, @V_INCID_CDMENSAGEM,
                                              @V_INCID_CDDETALHEPROD, @V_INCID_CDENQLEGALIPI,
                                              @V_INCID_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_COUNT = COUNT(*)
                 FROM INCITEMP
                WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                  AND CDIMPOTEMP = @V_INCID_CDIMPOSTO;

               IF @V_COUNT = 0 BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                      @V_INCID_CDFISCAL, @V_DSMENSINCID, NULL, @V_INCID_CDDETALHEPROD,
                      @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);
               END;
               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_IDINCINTEREST, @V_INCID_CDMENSAGEM,
                                                 @V_INCID_CDDETALHEPROD, @V_INCID_CDENQLEGALIPI,
                                                 @V_INCID_CDCEST;
            END;
            CLOSE C_INCIDENCIA;
            DEALLOCATE C_INCIDENCIA;
         END
         ELSE IF (@V_CDARVPROD IS NULL) BEGIN
            DECLARE C_INCIDNULL CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID,
                      ISNULL(I.IDINCINTEREST, 'N') IDINCINTEREST, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                   ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                  AND (I.CDEMPRESA    = @P_EMPRESA)
                  AND (I.CDTIPOOPER   = @P_TIPOOPER)
                  AND (I.CDIMPOSTO    = @V_CDIMPOSTO)
                  AND (I.CDINSCESTA   IS NULL)
                  AND (I.CDGRUPOFISC  IS NULL)
                  AND I.IDINCINTEREST = 'N'
                  AND (CDPRODUTO IS NULL);
            OPEN C_INCIDNULL;

            FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                             @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                             @V_INCIDN_IDINCINTEREST, @V_INCIDN_CDMENSAGEM,
                                             @V_INCIDN_CDDETALHEPROD, @V_INCIDN_CDENQLEGALIPI,
                                             @V_INCIDN_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SELECT @V_COUNT = COUNT(*)
                 FROM INCITEMP
                WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                  AND CDIMPOTEMP = @V_INCIDN_CDIMPOSTO;

               IF @V_COUNT = 0 BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES(@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                         @V_INCIDN_CDFISCAL, @V_DSMENSINCID, NULL, @V_INCIDN_CDDETALHEPROD,
                         @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);
               END;
               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_IDINCINTEREST, @V_INCIDN_CDMENSAGEM,
                                                @V_INCIDN_CDDETALHEPROD, @V_INCIDN_CDENQLEGALIPI,
                                                @V_INCIDN_CDCEST;
            END;
            CLOSE C_INCIDNULL;
            DEALLOCATE C_INCIDNULL;
         END;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD, @V_CDIMPOSTO;
      END;
      CLOSE C_IMPOSTO;
      DEALLOCATE C_IMPOSTO;
   END;

   /* Verificao das incidncias referente as filiais parametrizadas na tela Parmetros de Grupo Fiscal (Imposto/Filial) */
   DECLARE C_IMPFILI CURSOR FOR
      SELECT G.CDIMPOSTO, G.CDGRUPOFISC
        FROM GRUPOFISCIMPFIL G,
             (SELECT (CASE @P_ENTRSAIDIN WHEN 'E' THEN CDFILIRECE ELSE CDFILIEMIT END) AS CDFILIAL
                FROM NOTAFISCAL
               WHERE CDFILIAL = @P_FILIAL
                 AND NRLANCTONF = @P_LANCTONF
                 AND @P_IDSISTEMA IS NULL
                 AND @P_CDFILIRECE IS NULL
              UNION ALL
              SELECT CDFILIAL
                FROM PEDIDO
               WHERE CDFILIAL = SUBSTRING(@P_FILIAL,1,4)
                 AND NRPEDIDO = SUBSTRING(@P_FILIAL,5,10)
                 AND @P_IDSISTEMA = 'PED'
               UNION ALL
              SELECT CDFILIAL
                FROM FILIAL
               WHERE CDFILIAL = @P_CDFILIRECE) F
       WHERE G.CDFILIAL = F.CDFILIAL
         AND NOT G.CDGRUPOFISC IS NULL;

   OPEN C_IMPFILI;
   FETCH NEXT FROM C_IMPFILI INTO @V_IMPFILI_CDIMPOSTO, @V_IMPFILI_CDGRUPOFISC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      /* Operao Interestadual */
      IF @P_IDINCINTEREST = 'S' BEGIN

         DECLARE C_IMPOSTO CURSOR FOR
            SELECT MAX(P.CDARVPROD) AS CDARVPROD
              FROM INCIDENCIA I LEFT JOIN PRODUTO P
                                ON (I.CDPRODUTO = P.CDPRODUTO), IMPOSTO IP
             WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
               AND (I.CDEMPRESA = @P_EMPRESA)
               AND (I.CDTIPOOPER = @P_TIPOOPER)
               AND (I.CDINSCESTA IS NULL)
               AND ((I.CDGRUPOFISC = @V_IMPFILI_CDGRUPOFISC) AND (IP.IDGRUPFISSRV <> 'S'))
               AND (I.CDIMPOSTO = @V_IMPFILI_CDIMPOSTO)
               AND (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')), ISNULL(@P_PRODUTO,'_')) = 1)
               AND I.IDINCINTEREST = 'S'
               AND (I.CDIMPOSTO = IP.CDIMPOSTO);
         OPEN C_IMPOSTO;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT @V_EXISTE = COUNT(*)
              FROM INCITEMP
             WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
               AND CDIMPOTEMP = @V_IMPFILI_CDIMPOSTO
               AND NOT CDINSCESTAITMP IS NULL;

            IF @V_EXISTE = 0 BEGIN
               DELETE FROM INCITEMP
                WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
                  AND CDIMPOTEMP = @V_IMPFILI_CDIMPOSTO;
            END;

            IF NOT (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_INCIDENCIA CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                      ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                      LEFT JOIN PRODUTO P
                                      ON (I.CDPRODUTO = P.CDPRODUTO)
                   WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                     AND (I.CDEMPRESA = @P_EMPRESA)
                     AND (I.CDTIPOOPER = @P_TIPOOPER)
                     AND (I.CDGRUPOFISC = @V_IMPFILI_CDGRUPOFISC)
                     AND (I.CDIMPOSTO = @V_IMPFILI_CDIMPOSTO)
                     AND (I.CDINSCESTA IS NULL)
                     AND I.IDINCINTEREST = 'S'
                     AND (P.CDARVPROD = @V_CDARVPROD);
               OPEN C_INCIDENCIA;
               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                      @V_INCID_CDFISCAL, @V_DSMENSINCID, NULL, @V_INCID_CDDETALHEPROD,
                      @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                                 @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                                 @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                                 @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
               END;
               CLOSE C_INCIDENCIA;
               DEALLOCATE C_INCIDENCIA;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_INCIDNULL CURSOR FOR
                  SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                         I.CDCEST
                    FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                      ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                   WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                     AND (I.CDEMPRESA = @P_EMPRESA)
                     AND (I.CDTIPOOPER = @P_TIPOOPER)
                     AND (I.CDGRUPOFISC = @V_IMPFILI_CDGRUPOFISC)
                     AND (I.CDIMPOSTO = @V_IMPFILI_CDIMPOSTO)
                     AND (I.CDINSCESTA IS NULL)
                     AND I.IDINCINTEREST = 'S'
                     AND (CDPRODUTO IS NULL);
               OPEN C_INCIDNULL;
               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSINCID = NULL;
                  END
                  ELSE BEGIN
                     SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
                  END;

                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                      CDENQLEGALIPI, CDCEST)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                      @V_INCIDN_CDFISCAL, @V_DSMENSINCID, NULL, @V_INCIDN_CDDETALHEPROD,
                      @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
               END;
               CLOSE C_INCIDNULL;
               DEALLOCATE C_INCIDNULL;
            END;
            FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;
         END;
         CLOSE C_IMPOSTO;
         DEALLOCATE C_IMPOSTO;
      END;

      DECLARE C_IMPOSTO CURSOR FOR
         SELECT MAX(P.CDARVPROD) AS CDARVPROD
           FROM INCIDENCIA I LEFT JOIN PRODUTO P
                             ON (I.CDPRODUTO = P.CDPRODUTO), IMPOSTO IP
          WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
            AND (I.CDEMPRESA = @P_EMPRESA)
            AND (I.CDTIPOOPER = @P_TIPOOPER)
            AND (I.CDINSCESTA IS NULL)
            AND ((I.CDGRUPOFISC = @V_IMPFILI_CDGRUPOFISC) AND (IP.IDGRUPFISSRV <> 'S'))
            AND (I.CDIMPOSTO = @V_IMPFILI_CDIMPOSTO)
            AND (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),ISNULL(@P_PRODUTO,'_')), ISNULL(@P_PRODUTO,'_')) = 1)
            AND I.IDINCINTEREST = 'N'
            AND (I.CDIMPOSTO = IP.CDIMPOSTO);
      OPEN C_IMPOSTO;
      FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT @V_EXISTE = COUNT(*)
           FROM INCITEMP
          WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
            AND CDIMPOTEMP = @V_IMPFILI_CDIMPOSTO
            AND NOT CDINSCESTAITMP IS NULL;

         IF @V_EXISTE = 0 BEGIN
            DELETE FROM INCITEMP
             WHERE NRINCITEMP = @P_FILIAL+@P_LANCTONF
               AND CDIMPOTEMP = @V_IMPFILI_CDIMPOSTO;
         END;

         IF NOT (@V_CDARVPROD IS NULL) BEGIN
            DECLARE C_INCIDENCIA CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI, 
                      I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                   ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                                   LEFT JOIN PRODUTO P
                                   ON (I.CDPRODUTO = P.CDPRODUTO)
                WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                  AND (I.CDEMPRESA = @P_EMPRESA)
                  AND (I.CDTIPOOPER = @P_TIPOOPER)
                  AND (I.CDGRUPOFISC = @V_IMPFILI_CDGRUPOFISC)
                  AND (I.CDIMPOSTO = @V_IMPFILI_CDIMPOSTO)
                  AND (I.CDINSCESTA IS NULL)
                  AND I.IDINCINTEREST = 'N'
                  AND (P.CDARVPROD = @V_CDARVPROD);
            OPEN C_INCIDENCIA;
            FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                              @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                              @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                              @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCID_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCID_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCID_CDIMPOSTO, @V_INCID_IDTRATIMPOIN,
                   @V_INCID_CDFISCAL, @V_DSMENSINCID, NULL, @V_INCID_CDDETALHEPROD,
                   @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCID_IDTRATIMPOIN, @V_INCID_CDIMPOSTO,
                                              @V_INCID_CDFISCAL, @V_INCID_DSMENSINCID,
                                              @V_INCID_CDMENSAGEM, @V_INCID_CDDETALHEPROD,
                                              @V_INCID_CDENQLEGALIPI, @V_INCID_CDCEST;
            END;
            CLOSE C_INCIDENCIA;
            DEALLOCATE C_INCIDENCIA;
         END
         ELSE IF (@V_CDARVPROD IS NULL) BEGIN
            DECLARE C_INCIDNULL CURSOR FOR
               SELECT IDTRATIMPOIN, I.CDIMPOSTO, CDFISCAL, DSMENSINCID, CDMENSAGEM, CDDETALHEPROD, CDENQLEGALIPI,
                      I.CDCEST
                 FROM INCIDENCIA I LEFT JOIN MENSINCID M
                                   ON (I.NRINCIDENCIA = M.NRINCIDENCIA)
                WHERE (I.IDENTRSAIDIN = @P_ENTRSAIDIN)
                  AND (I.CDEMPRESA = @P_EMPRESA)
                  AND (I.CDTIPOOPER = @P_TIPOOPER)
                  AND (I.CDGRUPOFISC = @V_IMPFILI_CDGRUPOFISC)
                  AND (I.CDIMPOSTO = @V_IMPFILI_CDIMPOSTO)
                  AND (I.CDINSCESTA IS NULL)
                  AND I.IDINCINTEREST = 'N'
                  AND (CDPRODUTO IS NULL);
            OPEN C_INCIDNULL;
            FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                             @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                             @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                             @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_COUNTMENS = COUNT(*)
                 FROM MENSAGEM
                WHERE CDMENSAGEM = @V_INCIDN_CDMENSAGEM
                  AND IDSITUACAOMENS = 'I';

               IF @V_COUNTMENS > 0 BEGIN
                  SET @V_DSMENSINCID = NULL;
               END
               ELSE BEGIN
                  SET @V_DSMENSINCID = @V_INCIDN_DSMENSINCID;
               END;

               INSERT INTO INCITEMP
                  (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                   CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD,
                   CDENQLEGALIPI, CDCEST)
               VALUES
                  (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_INCIDN_CDIMPOSTO, @V_INCIDN_IDTRATIMPOIN,
                   @V_INCIDN_CDFISCAL, @V_DSMENSINCID, NULL, @V_INCIDN_CDDETALHEPROD,
                   @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2);

               FETCH NEXT FROM C_INCIDNULL INTO @V_INCIDN_IDTRATIMPOIN, @V_INCIDN_CDIMPOSTO,
                                                @V_INCIDN_CDFISCAL, @V_INCIDN_DSMENSINCID,
                                                @V_INCIDN_CDMENSAGEM, @V_INCIDN_CDDETALHEPROD,
                                                @V_INCIDN_CDENQLEGALIPI, @V_INCIDN_CDCEST;
            END;
            CLOSE C_INCIDNULL;
            DEALLOCATE C_INCIDNULL;
         END;
         FETCH NEXT FROM C_IMPOSTO INTO @V_CDARVPROD;
      END;
      CLOSE C_IMPOSTO;
      DEALLOCATE C_IMPOSTO;

      FETCH NEXT FROM C_IMPFILI INTO @V_IMPFILI_CDIMPOSTO, @V_IMPFILI_CDGRUPOFISC;
   END;
   CLOSE C_IMPFILI;
   DEALLOCATE C_IMPFILI;

   SET @V_IDPRESENCIAL = '9';
   IF (@P_LANCPRODUTO IS NULL) BEGIN
      SELECT @V_INIVALID = ISNULL(MAX(N.DTENTRSAID), @P_INIVALID), 
             @V_CDFILIEMIT = MAX(N.CDFILIEMIT), 
             @V_IDORIGDESTNF = MAX(N.IDORIGDESTNF), 
             @V_CDCLIENTE = MAX(N.CDCLIENTE),
             @V_CDFILIRECE = MAX(N.CDFILIRECE), 
             @V_CDFORNECED = MAX(N.CDFORNECED), 
             @V_VRITEM = (MAX(IT.VRTOTAITEM) - MAX(IT.VRDESCITEM)),
             @V_IDPRESENCIAL = ISNULL(MAX(N.IDPRESENCIAL), '9')
        FROM NOTAFISCAL N, ITEMPRODUTO IT, PRODUTO P
       WHERE N.CDFILIAL = @P_FILIAL
         AND N.NRLANCTONF = @P_LANCTONF
         AND N.CDFILIAL = IT.CDFILIAL
         AND N.NRLANCTONF = IT.NRLANCTONF
         AND IT.CDPRODUTO = P.CDPRODUTO
         AND P.CDARVPROD  = @P_PRODUTO;
   END;

   SET @V_CDFILIRECE = ISNULL(@V_CDFILIRECE, @P_CDFILIRECE);
   SET @V_CDFORNECED = ISNULL(@V_CDFORNECED, @P_CDFORNECED);
   SET @V_CDCLIENTE  = ISNULL(@V_CDCLIENTE,  @P_CDCLIENTE);
   SET @V_CDFILIEMIT = ISNULL(@V_CDFILIEMIT, @P_CDFILIEMIT);

   IF (@P_LANCPRODUTO = 'S') BEGIN
      SET @V_VRITEM = @P_VRPRODUTO;
   END;

   IF (@P_ENTRSAIDIN = 'S') BEGIN
      SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPFIL),'I'), @V_CDEMPRESA = MAX(CDEMPRESA), @V_CDINSCESTA = MAX(CDINSCESTA)
        FROM FILIAL
       WHERE (CDFILIAL = @V_CDFILIEMIT);

      IF (@V_IDENDCFOP = 'I') BEGIN
         SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
           FROM INSCRESTAD
          WHERE CDEMPRESA  = @P_EMPRESA
            AND CDINSCESTA = @P_INSCESTA;
      END
      ELSE BEGIN
         SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
           FROM ENDEFILI
          WHERE (CDFILIAL     = @V_CDFILIEMIT)
            AND (IDTPENDEFILI = @V_IDENDCFOP);
      END;

      /*DESTINATRIO-REMETENTE DA NOTA*/
      IF (@V_IDORIGDESTNF IS NULL) BEGIN
         SELECT @V_ORIGDESTOP = MAX(IDORIGDESTOP)
           FROM TIPOOPERAC
          WHERE IDENTRSAIDOP = 'S'
            AND CDTIPOOPER   = @P_TIPOOPER;
      END
      ELSE BEGIN
         SET @V_ORIGDESTOP = @V_IDORIGDESTNF;
      END;

      IF (@V_ORIGDESTOP = 'L') BEGIN /*DESTINATARIO -> FILIAL */
         SET @V_CDORIGDESTNF = @V_CDFILIRECE;

         SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPFIL),'I'), @V_IDENDEMIS = ISNULL(MAX(IDENDEMISFIL),'I'), @V_CDEMPRESA = MAX(CDEMPRESA), @V_CDINSCESTA = MAX(CDINSCESTA)
           FROM FILIAL
          WHERE (CDFILIAL = @V_CDFILIRECE);

         IF (@V_IDENDEMIS = 'I') BEGIN
            SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO), @V_MUNIDEST = MAX(CDMUNICIPIO)
              FROM INSCRESTAD
             WHERE CDEMPRESA  = @V_CDEMPRESA
               AND CDINSCESTA = @V_CDINSCESTA;
         END
         ELSE BEGIN
            SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO), @V_MUNIDEST = MAX(CDMUNICIPIO)
              FROM ENDEFILI
             WHERE CDFILIAL     = @V_CDFILIRECE
               AND IDTPENDEFILI = @V_IDENDEMIS;
         END;
      END
      ELSE IF (@V_ORIGDESTOP = 'F') BEGIN /*DESTINATARIO -> FORNECEDOR */
         SET @V_CDORIGDESTNF = @V_CDFORNECED;

         SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPFOR),'P'), @V_IDENDEMIS = ISNULL(MAX(IDENDEMISFOR),'P')
           FROM FORNECEDOR
          WHERE (CDFORNECED = @V_CDORIGDESTNF);


         SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO), @V_MUNIDEST = MAX(CDMUNICIPIO)
           FROM ENDEFORN
          WHERE (CDFORNECED   = @V_CDORIGDESTNF)
            AND (IDTPENDEFORN = @V_IDENDEMIS);
      END
      ELSE BEGIN/*DESTINATARIO -> CLIENTE(DEFAULT) */
         SET @V_CDORIGDESTNF = @V_CDCLIENTE;

         SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPCLI),'P'), @V_IDENDEMIS = ISNULL(MAX(IDENDEMISCLI),'P')
           FROM CLIENTE
          WHERE (CDCLIENTE = @V_CDORIGDESTNF);

         IF (@V_IDENDCFOP = 'I') BEGIN
            SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO), @V_MUNIDEST = MAX(CDMUNICIPIO)
              FROM INSCRESTAD
             WHERE CDEMPRESA  = @P_EMPRESA
               AND CDINSCESTA = @P_INSCESTA;
         END
         ELSE BEGIN
            SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO), @V_MUNIDEST = MAX(CDMUNICIPIO)
              FROM ENDECLIE
             WHERE (CDCLIENTE    = @V_CDORIGDESTNF)
               AND (IDTPENDECLIE = @V_IDENDEMIS);
         END;
      END;
      /*
      QUANDO A OPERAO DA NOTA FISCAL FOR PRESENCIAL O SISTEMA USAR COMO ENDEREO
      DE DESTINO O MESMO ENDEREO DA ORIGEM. EST CONDIO FOI NECESSRIA PARA ATENDER 
      A NOTA TCNICA 2015/003
      */
      IF @V_IDPRESENCIAL = '1' BEGIN
         SET @V_PAISDEST = @V_PAISORIG;
         SET @V_ESTADEST = @V_ESTAORIG;
         SET @V_MUNIDEST = @V_MUNIORIG;
      END;
   END;

   IF (@P_ENTRSAIDIN = 'E') BEGIN

      SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPFIL),'I'),
             @V_CDEMPRESA = MAX(CDEMPRESA), @V_CDINSCESTA = MAX(CDINSCESTA)
        FROM FILIAL
       WHERE (CDFILIAL = ISNULL(@V_CDFILIRECE, @P_CDFILIRECE));

      SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO), @V_MUNIDEST = MAX(CDMUNICIPIO)
        FROM INSCRESTAD
       WHERE CDEMPRESA  = @P_EMPRESA
         AND CDINSCESTA = @P_INSCESTA;

      SELECT @V_IDNFPRESTSERV = ISNULL(MAX(IDNFPRESTSERV), 'N')
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = 'E'
         AND CDTIPOOPER   = @P_TIPOOPER;

      IF @V_IDNFPRESTSERV = 'S' BEGIN

         SELECT @V_IDENTEMIS = ISNULL(MAX(IDENDEMISFIL),'P')
           FROM FILIAL
          WHERE (CDFILIAL = @V_CDFILIRECE);

         IF @V_IDENTEMIS = 'I' BEGIN
            SET @V_IDENTEMIS = 'P';
         END;

         SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO), @V_MUNIDEST = MAX(CDMUNICIPIO)
           FROM ENDEFILI
          WHERE CDFILIAL     = @V_CDFILIRECE
            AND IDTPENDEFILI = @V_IDENTEMIS;
      END;
      /*DESTINATRIO-REMETENTE DA NOTA*/
      IF @V_IDORIGDESTNF IS NULL BEGIN
         SELECT @V_ORIGDESTOP = MAX(ISNULL(IDORIGDESTOP, 'F'))
           FROM TIPOOPERAC
          WHERE IDENTRSAIDOP = 'E' AND
                CDTIPOOPER   = @P_TIPOOPER;
      END
      ELSE BEGIN
        SET @V_ORIGDESTOP = @V_IDORIGDESTNF;
      END;

      IF @V_ORIGDESTOP = 'L' BEGIN /*Remetente -> FILIAL */
         SET @V_CDORIGDESTNF  = @V_CDFILIEMIT;

         SELECT @V_IDENDCFOP  = MAX(ISNULL(IDENDCFOPFIL,'I')),
                @V_IDENDEMIS  = MAX(ISNULL(IDENDEMISFIL,'I')),
                @V_CDEMPRESA  = MAX(CDEMPRESA),
                @V_CDINSCESTA = MAX(CDINSCESTA)
           FROM FILIAL
          WHERE (CDFILIAL = @V_CDFILIEMIT);

         IF @V_IDENDEMIS = 'I' BEGIN
            SELECT @V_PAISORIG = MAX(CDPAIS),
                   @V_ESTAORIG = MAX(SGESTADO),
                   @V_MUNIORIG = MAX(CDMUNICIPIO)
              FROM INSCRESTAD
             WHERE CDEMPRESA   = @V_CDEMPRESA
               AND CDINSCESTA  = @V_CDINSCESTA;
         END
         ELSE BEGIN
            SELECT @V_PAISORIG = MAX(CDPAIS),
                   @V_ESTAORIG = MAX(SGESTADO),
                   @V_MUNIORIG = MAX(CDMUNICIPIO)
              FROM ENDEFILI
             WHERE CDFILIAL     = @V_CDFILIEMIT
               AND IDTPENDEFILI = @V_IDENDEMIS;
         END;
      END   
      ELSE IF @V_ORIGDESTOP = 'F' BEGIN /*DESTINATARIO -> FORNECEDOR */
         SET @V_CDORIGDESTNF = @V_CDFORNECED;

         SELECT @V_IDENDCFOP = MAX(ISNULL(IDENDCFOPFOR,'P')),
                @V_IDENDEMIS = MAX(ISNULL(IDENDEMISFOR,'P'))
           FROM FORNECEDOR
          WHERE (CDFORNECED = ISNULL(@V_CDORIGDESTNF, @P_CDFORNECED));

         SELECT @V_PAISORIG = MAX(CDPAIS),
                @V_ESTAORIG = MAX(SGESTADO),
                @V_MUNIORIG = MAX(CDMUNICIPIO)
           FROM ENDEFORN
          WHERE (CDFORNECED   = ISNULL(@V_CDORIGDESTNF, @P_CDFORNECED))
            AND (IDTPENDEFORN = @V_IDENDCFOP);
      END      
      ELSE BEGIN /*DESTINATARIO -> CLIENTE */
         SET @V_CDORIGDESTNF = @V_CDCLIENTE;

         SELECT @V_IDENDCFOP = MAX(ISNULL(IDENDCFOPCLI,'P')),
                @V_IDENDEMIS = MAX(ISNULL(IDENDEMISCLI,'P'))
           FROM CLIENTE
          WHERE (CDCLIENTE = ISNULL(@V_CDORIGDESTNF, @P_CDCLIENTE));

         IF @V_IDENDCFOP = 'I' BEGIN
            SELECT @V_PAISORIG = MAX(CDPAIS),
                   @V_ESTAORIG = MAX(SGESTADO),
                   @V_MUNIORIG = MAX(CDMUNICIPIO)
              FROM INSCRESTAD
             WHERE CDEMPRESA  = @P_EMPRESA
               AND CDINSCESTA = @P_INSCESTA;
         END
         ELSE BEGIN
            SELECT @V_PAISORIG = MAX(CDPAIS),
                   @V_ESTAORIG = MAX(SGESTADO),
                   @V_MUNIORIG = MAX(CDMUNICIPIO)

              FROM ENDECLIE
              WHERE (CDCLIENTE    = ISNULL(@V_CDORIGDESTNF, @P_CDCLIENTE))
                AND (IDTPENDECLIE = @V_IDENDEMIS);
         END;
      END;
   END;
   DECLARE C_REGRA CURSOR FOR
      SELECT CDIMPOSTO, CDFISCAL, CDREGRAFISC, IDMENSAGEM, IDTIPOREGISTRO, NRSEQDADOSFISC,
             CDCLASFISC, CDPRODUTO, CDDETALHEFISC, CDENQLEGALIPI, CDCEST, VRADICALIQFECP
        FROM TEKNISA.CONSULTA_REGRA_FISCAL(@V_IMPFILI_CDIMPOSTO, @P_EMPRESA, @P_CDGRUPOFISC, @P_ENTRSAIDIN, @P_TIPOOPER, @P_INSCESTA, @P_PRODUTO, @V_INIVALID,
                                           @V_PAISORIG, @V_ESTAORIG, @V_MUNIORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_VRITEM, 'N', @P_IDORIGEMPROD)
       WHERE VRALIQUOTA IS NOT NULL;

   OPEN C_REGRA;
   FETCH NEXT FROM C_REGRA INTO @V_REGRA_CDIMPOSTO, @V_REGRA_CDFISCAL, @V_REGRA_CDREGRAFISC, @V_REGRA_IDMENSAGEM, @V_REGRA_IDTIPOREGISTRO, @V_REGRA_NRSEQDADOSFISC,
                                @V_REGRA_CDCLASFISC, @V_REGRA_CDPRODUTO, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT @V_EXISTE =COUNT(*)
        FROM INCITEMP
       WHERE NRINCITEMP  = @P_FILIAL+@P_LANCTONF
         AND CDIMPOTEMP = @V_REGRA_CDIMPOSTO
         AND CDREGRATMP IS NULL;

      IF (@V_EXISTE > 0) BEGIN
         DELETE FROM INCITEMP
         WHERE NRINCITEMP  = @P_FILIAL+@P_LANCTONF
           AND CDIMPOTEMP = @V_REGRA_CDIMPOSTO
           AND CDREGRATMP IS NULL;
      END;

      SELECT @V_IDTRATIMPO = MAX(IDTRATIMPO)
        FROM IMPOSTO
       WHERE CDIMPOSTO = @V_REGRA_CDIMPOSTO;

      IF @V_REGRA_IDMENSAGEM = 'S' BEGIN
         IF @V_REGRA_IDTIPOREGISTRO = 'PAD' BEGIN

            DECLARE C_MSGREGRA CURSOR FOR
               SELECT DSMENSAGEM
                 FROM MSGFISCREGRA
                WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                  AND CDIMPOSTO = @V_REGRA_CDIMPOSTO
                  AND NRSEQDADOSFISC = @V_REGRA_NRSEQDADOSFISC;
            OPEN C_MSGREGRA;
            FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               INSERT INTO INCITEMP
                 (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                  CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
                  CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
               VALUES
                 (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
                  @V_REGRA_CDFISCAL, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
                  @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

               SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
               FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
           END;
           CLOSE C_MSGREGRA;
           DEALLOCATE C_MSGREGRA;
         END
         ELSE BEGIN
            IF @V_REGRA_IDTIPOREGISTRO = 'NCM' BEGIN
               DECLARE C_MSGREGRA CURSOR FOR
                  SELECT DSMENSAGEM
                    FROM MSGFISCNCM
                   WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                     AND CDIMPOSTO = @V_REGRA_CDIMPOSTO
                     AND CDCLASFISC = @V_REGRA_CDCLASFISC
                     AND NRSEQDADOSFISC = @V_REGRA_NRSEQDADOSFISC;
               OPEN C_MSGREGRA;
               FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  INSERT INTO INCITEMP
                     (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                      CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
                      CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
                      @V_REGRA_CDFISCAL, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
                      @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
                  FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
               END;
               CLOSE C_MSGREGRA;
               DEALLOCATE C_MSGREGRA;
            END
            ELSE BEGIN
               IF @V_REGRA_IDTIPOREGISTRO = 'PROD' BEGIN
                  DECLARE C_MSGREGRA CURSOR FOR
                     SELECT DSMENSAGEM
                       FROM MSGFISCPROD
                      WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                        AND CDIMPOSTO = @V_REGRA_CDIMPOSTO
                        AND NRSEQDADOSFISC = @V_REGRA_NRSEQDADOSFISC
                        AND CDPRODUTO = @V_REGRA_CDPRODUTO;
                  OPEN C_MSGREGRA;
                  FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     INSERT INTO INCITEMP
                        (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                         CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
                         CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
                     VALUES
                        (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
                         @V_REGRA_CDFISCAL, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
                         @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

                     SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
                     FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                  END;
                  CLOSE C_MSGREGRA;
                  DEALLOCATE C_MSGREGRA;
               END;
            END;
         END;
      END
      ELSE BEGIN
         INSERT INTO INCITEMP
           (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
            CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
            CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
         VALUES
           (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
            @V_REGRA_CDFISCAL, NULL, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
            @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

         SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
      END;
      FETCH NEXT FROM C_REGRA INTO @V_REGRA_CDIMPOSTO, @V_REGRA_CDFISCAL, @V_REGRA_CDREGRAFISC, @V_REGRA_IDMENSAGEM, @V_REGRA_IDTIPOREGISTRO, @V_REGRA_NRSEQDADOSFISC,
                                @V_REGRA_CDCLASFISC, @V_REGRA_CDPRODUTO, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP;
   END;
   CLOSE C_REGRA;
   DEALLOCATE C_REGRA;

   /* Verificao das incidncias referente as filiais parametrizadas na tela Parmetros de Grupo Fiscal (Imposto/Filial) */
   DECLARE C_IMPFILI CURSOR FOR
      SELECT G.CDIMPOSTO, G.CDGRUPOFISC
        FROM GRUPOFISCIMPFIL G,
             (SELECT (CASE @P_ENTRSAIDIN WHEN 'E' THEN CDFILIRECE ELSE CDFILIEMIT END) AS CDFILIAL
                FROM NOTAFISCAL
               WHERE CDFILIAL = @P_FILIAL
                 AND NRLANCTONF = @P_LANCTONF
                 AND @P_IDSISTEMA IS NULL
                 AND @P_CDFILIRECE IS NULL
              UNION ALL
              SELECT CDFILIAL
                FROM PEDIDO
               WHERE CDFILIAL = SUBSTRING(@P_FILIAL,1,4)
                 AND NRPEDIDO = SUBSTRING(@P_FILIAL,5,10)
                 AND @P_IDSISTEMA = 'PED'
               UNION ALL
              SELECT CDFILIAL
                FROM FILIAL
               WHERE CDFILIAL = @P_CDFILIRECE) F
       WHERE G.CDFILIAL = F.CDFILIAL
         AND NOT G.CDGRUPOFISC IS NULL;

   OPEN C_IMPFILI;
   FETCH NEXT FROM C_IMPFILI INTO @V_IMPFILI_CDIMPOSTO, @V_IMPFILI_CDGRUPOFISC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      DECLARE C_REGRA CURSOR FOR
         SELECT CDIMPOSTO, CDFISCAL, CDREGRAFISC, IDMENSAGEM, IDTIPOREGISTRO, NRSEQDADOSFISC,
                CDCLASFISC, CDPRODUTO, CDDETALHEFISC, CDENQLEGALIPI, CDCEST, VRADICALIQFECP
            FROM TEKNISA.CONSULTA_REGRA_FISCAL(@V_IMPFILI_CDIMPOSTO, @P_EMPRESA, @V_IMPFILI_CDGRUPOFISC, @P_ENTRSAIDIN, @P_TIPOOPER, @P_INSCESTA, @P_PRODUTO, @V_INIVALID,
                                               @V_PAISORIG, @V_ESTAORIG, @V_MUNIORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_VRITEM, 'N', @P_IDORIGEMPROD)
          WHERE VRALIQUOTA IS NOT NULL;


      OPEN C_REGRA;
      FETCH NEXT FROM C_REGRA INTO @V_REGRA_CDIMPOSTO, @V_REGRA_CDFISCAL, @V_REGRA_CDREGRAFISC, @V_REGRA_IDMENSAGEM, @V_REGRA_IDTIPOREGISTRO, @V_REGRA_NRSEQDADOSFISC,
                                   @V_REGRA_CDCLASFISC, @V_REGRA_CDPRODUTO, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT @V_EXISTE = COUNT(*)
           FROM INCITEMP
          WHERE NRINCITEMP  = @P_FILIAL+@P_LANCTONF
            AND CDIMPOTEMP = @V_REGRA_CDIMPOSTO;

         IF (@V_EXISTE > 0) BEGIN
            DELETE FROM INCITEMP
            WHERE NRINCITEMP  = @P_FILIAL+@P_LANCTONF
              AND CDIMPOTEMP = @V_REGRA_CDIMPOSTO;
         END;

         SELECT @V_IDTRATIMPO = MAX(IDTRATIMPO)
           FROM IMPOSTO
          WHERE CDIMPOSTO = @V_REGRA_CDIMPOSTO;

         IF @V_REGRA_IDMENSAGEM = 'S' BEGIN
            IF @V_REGRA_IDTIPOREGISTRO = 'PAD' BEGIN

               DECLARE C_MSGREGRA CURSOR FOR
                  SELECT DSMENSAGEM
                    FROM MSGFISCREGRA
                   WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                     AND CDIMPOSTO = @V_REGRA_CDIMPOSTO
                     AND NRSEQDADOSFISC = @V_REGRA_NRSEQDADOSFISC;
               OPEN C_MSGREGRA;
               FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  INSERT INTO INCITEMP
                    (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                     CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
                     CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
                  VALUES
                    (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
                     @V_REGRA_CDFISCAL, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
                     @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
                  FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
               END;
               CLOSE C_MSGREGRA;
               DEALLOCATE C_MSGREGRA;
            END
            ELSE BEGIN
               IF @V_REGRA_IDTIPOREGISTRO = 'NCM' BEGIN
                  DECLARE C_MSGREGRA CURSOR FOR
                     SELECT DSMENSAGEM
                       FROM MSGFISCNCM
                      WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                        AND CDIMPOSTO = @V_REGRA_CDIMPOSTO
                        AND CDCLASFISC = @V_REGRA_CDCLASFISC
                        AND NRSEQDADOSFISC = @V_REGRA_NRSEQDADOSFISC;
                  OPEN C_MSGREGRA;
                  FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     INSERT INTO INCITEMP
                        (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                         CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
                         CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
                     VALUES
                        (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
                         @V_REGRA_CDFISCAL, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
                         @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

                     SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
                     FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                  END;
                  CLOSE C_MSGREGRA;
                  DEALLOCATE C_MSGREGRA;
               END
               ELSE BEGIN
                  IF @V_REGRA_IDTIPOREGISTRO = 'PROD' BEGIN
                     DECLARE C_MSGREGRA CURSOR FOR
                        SELECT DSMENSAGEM
                          FROM MSGFISCPROD
                         WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                           AND CDIMPOSTO = @V_REGRA_CDIMPOSTO
                           AND NRSEQDADOSFISC = @V_REGRA_NRSEQDADOSFISC
                           AND CDPRODUTO = @V_REGRA_CDPRODUTO;
                     OPEN C_MSGREGRA;
                     FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                     WHILE (@@FETCH_STATUS = 0) BEGIN
                        INSERT INTO INCITEMP
                           (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                            CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
                            CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
                        VALUES
                           (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
                            @V_REGRA_CDFISCAL, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
                            @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

                        SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
                        FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                     END;
                     CLOSE C_MSGREGRA;
                     DEALLOCATE C_MSGREGRA;
                  END;
               END;
            END;
         END
         ELSE BEGIN
            INSERT INTO INCITEMP
              (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
               CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
               CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
            VALUES
              (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
               @V_REGRA_CDFISCAL, NULL, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
               @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

            SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
         END;
         FETCH NEXT FROM C_REGRA INTO @V_REGRA_CDIMPOSTO, @V_REGRA_CDFISCAL, @V_REGRA_CDREGRAFISC, @V_REGRA_IDMENSAGEM, @V_REGRA_IDTIPOREGISTRO, @V_REGRA_NRSEQDADOSFISC,
                                      @V_REGRA_CDCLASFISC, @V_REGRA_CDPRODUTO, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP;
      END;
      CLOSE C_REGRA;
      DEALLOCATE C_REGRA;
      FETCH NEXT FROM C_IMPFILI INTO @V_IMPFILI_CDIMPOSTO, @V_IMPFILI_CDGRUPOFISC;
   END;
   CLOSE C_IMPFILI;
   DEALLOCATE C_IMPFILI;


   /* Verificao das incidncias referente as filiais parametrizadas na tela Parmetros de Grupo Fiscal (Imposto/Inscrio Estadual) */
   /* Por Fornecedor */
   DECLARE C_IMPINSCESTAFO CURSOR FOR
      SELECT G.CDIMPOSTO, G.CDGRUPOFISC
        FROM GRFISIMPIEFORN G,
             (SELECT CDFORNECED
                FROM NOTAFISCAL
               WHERE CDFILIAL = @P_FILIAL
                 AND NRLANCTONF = @P_LANCTONF) N
       WHERE G.CDFORNECED = N.CDFORNECED
         AND G.CDEMPRESA = @P_EMPRESA
         AND G.CDINSCESTA = @P_INSCESTA
         AND NOT G.CDGRUPOFISC IS NULL;

   OPEN C_IMPINSCESTAFO;
   FETCH NEXT FROM C_IMPINSCESTAFO INTO @V_IMPINSCESTAFO_CDIMPOSTO, @V_IMPINSCESTAFO_CDGRUPOFISC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      DECLARE C_REGRA CURSOR FOR
         SELECT CDIMPOSTO, CDFISCAL, CDREGRAFISC, IDMENSAGEM, IDTIPOREGISTRO, NRSEQDADOSFISC,
                CDCLASFISC, CDPRODUTO, CDDETALHEFISC, CDENQLEGALIPI, CDCEST, VRADICALIQFECP
           FROM TEKNISA.CONSULTA_REGRA_FISCAL(@V_IMPFILI_CDIMPOSTO, @P_EMPRESA, @V_IMPFILI_CDGRUPOFISC, @P_ENTRSAIDIN, @P_TIPOOPER, @P_INSCESTA, @P_PRODUTO, @V_INIVALID,
                                              @V_PAISORIG, @V_ESTAORIG, @V_MUNIORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_VRITEM, 'N', @P_IDORIGEMPROD)
          WHERE VRALIQUOTA IS NOT NULL;

      OPEN C_REGRA;
      FETCH NEXT FROM C_REGRA INTO @V_REGRA_CDIMPOSTO, @V_REGRA_CDFISCAL, @V_REGRA_CDREGRAFISC, @V_REGRA_IDMENSAGEM, @V_REGRA_IDTIPOREGISTRO, @V_REGRA_NRSEQDADOSFISC,
                                   @V_REGRA_CDCLASFISC, @V_REGRA_CDPRODUTO, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP;
      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT @V_EXISTE = COUNT(*)
           FROM INCITEMP
          WHERE NRINCITEMP  = @P_FILIAL+@P_LANCTONF
            AND CDIMPOTEMP = @V_REGRA_CDIMPOSTO;

         IF (@V_EXISTE > 0) BEGIN
            DELETE FROM INCITEMP
            WHERE NRINCITEMP  = @P_FILIAL+@P_LANCTONF
              AND CDIMPOTEMP = @V_REGRA_CDIMPOSTO;
         END;

         SELECT @V_IDTRATIMPO = MAX(IDTRATIMPO)
           FROM IMPOSTO
          WHERE CDIMPOSTO = @V_REGRA_CDIMPOSTO;

         IF @V_REGRA_IDMENSAGEM = 'S' BEGIN
            IF @V_REGRA_IDTIPOREGISTRO = 'PAD' BEGIN

               DECLARE C_MSGREGRA CURSOR FOR
                  SELECT DSMENSAGEM
                    FROM MSGFISCREGRA
                   WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                     AND CDIMPOSTO = @V_REGRA_CDIMPOSTO
                     AND NRSEQDADOSFISC = @V_REGRA_NRSEQDADOSFISC;
               OPEN C_MSGREGRA;
               FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  INSERT INTO INCITEMP
                    (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                     CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
                     CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
                  VALUES
                    (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
                     @V_REGRA_CDFISCAL, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
                     @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
                  FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
               END;
               CLOSE C_MSGREGRA;
               DEALLOCATE C_MSGREGRA;
            END
            ELSE BEGIN
               IF @V_REGRA_IDTIPOREGISTRO = 'NCM' BEGIN
                  DECLARE C_MSGREGRA CURSOR FOR
                     SELECT DSMENSAGEM
                       FROM MSGFISCNCM
                      WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                        AND CDIMPOSTO = @V_REGRA_CDIMPOSTO
                        AND CDCLASFISC = @V_REGRA_CDCLASFISC
                        AND NRSEQDADOSFISC = @V_REGRA_NRSEQDADOSFISC;
                  OPEN C_MSGREGRA;
                  FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     INSERT INTO INCITEMP
                       (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                        CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
                        CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
                     VALUES
                       (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
                        @V_REGRA_CDFISCAL, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
                        @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

                     SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
                     FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                  END;
                  CLOSE C_MSGREGRA;
                  DEALLOCATE C_MSGREGRA;
               END
               ELSE BEGIN
                  IF @V_REGRA_IDTIPOREGISTRO = 'PROD' BEGIN
                     DECLARE C_MSGREGRA CURSOR FOR
                        SELECT DSMENSAGEM
                          FROM MSGFISCPROD
                         WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                           AND CDIMPOSTO = @V_REGRA_CDIMPOSTO
                           AND NRSEQDADOSFISC = @V_REGRA_NRSEQDADOSFISC
                           AND CDPRODUTO = @V_REGRA_CDPRODUTO;
                     OPEN C_MSGREGRA;
                     FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                     WHILE (@@FETCH_STATUS = 0) BEGIN
                        INSERT INTO INCITEMP
                          (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                           CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
                           CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
                        VALUES
                          (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
                           @V_REGRA_CDFISCAL, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
                           @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

                        SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
                        FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                     END;
                     CLOSE C_MSGREGRA;
                     DEALLOCATE C_MSGREGRA;
                  END;
               END;
            END;
         END
         ELSE BEGIN
            INSERT INTO INCITEMP
              (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
               CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
               CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
            VALUES
              (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
               @V_REGRA_CDFISCAL, NULL, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
               @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

            SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
         END;
         FETCH NEXT FROM C_REGRA INTO @V_REGRA_CDIMPOSTO, @V_REGRA_CDFISCAL, @V_REGRA_CDREGRAFISC, @V_REGRA_IDMENSAGEM, @V_REGRA_IDTIPOREGISTRO, @V_REGRA_NRSEQDADOSFISC,
                                      @V_REGRA_CDCLASFISC, @V_REGRA_CDPRODUTO, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP;
      END;
      CLOSE C_REGRA;
      DEALLOCATE C_REGRA;
      FETCH NEXT FROM C_IMPINSCESTAFO INTO @V_IMPINSCESTAFO_CDIMPOSTO, @V_IMPINSCESTAFO_CDGRUPOFISC;
   END;
   CLOSE C_IMPINSCESTAFO;
   DEALLOCATE C_IMPINSCESTAFO;
   /* Verificao das incidncias referente as filiais parametrizadas na tela Parmetros de Grupo Fiscal (Imposto/Inscrio Estadual) */
   /* Por Cliente */
   DECLARE C_IMPINSCESTACL CURSOR FOR
      SELECT G.CDIMPOSTO, G.CDGRUPOFISC
        FROM GRFISIMPIECLIE G,
             (SELECT CDCLIENTE
                FROM NOTAFISCAL
               WHERE CDFILIAL = @P_FILIAL
                 AND NRLANCTONF = @P_LANCTONF) N
       WHERE G.CDCLIENTE = N.CDCLIENTE
         AND G.CDEMPRESA = @P_EMPRESA
         AND G.CDINSCESTA = @P_INSCESTA
         AND NOT G.CDGRUPOFISC IS NULL;

   OPEN C_IMPINSCESTACL;
   FETCH NEXT FROM C_IMPINSCESTACL INTO @V_IMPINSCESTACL_CDIMPOSTO, @V_IMPINSCESTACL_CDGRUPOFISC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      DECLARE C_REGRA CURSOR FOR
         SELECT CDIMPOSTO, CDFISCAL, CDREGRAFISC, IDMENSAGEM, IDTIPOREGISTRO, NRSEQDADOSFISC,
                CDCLASFISC, CDPRODUTO, CDDETALHEFISC, CDENQLEGALIPI, CDCEST, VRADICALIQFECP
           FROM TEKNISA.CONSULTA_REGRA_FISCAL(@V_IMPFILI_CDIMPOSTO, @P_EMPRESA, @V_IMPFILI_CDGRUPOFISC, @P_ENTRSAIDIN, @P_TIPOOPER, @P_INSCESTA, @P_PRODUTO, @V_INIVALID,
                                              @V_PAISORIG, @V_ESTAORIG, @V_MUNIORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_VRITEM, 'N', @P_IDORIGEMPROD)
          WHERE VRALIQUOTA IS NOT NULL;

      OPEN C_REGRA;
      FETCH NEXT FROM C_REGRA INTO @V_REGRA_CDIMPOSTO, @V_REGRA_CDFISCAL, @V_REGRA_CDREGRAFISC, @V_REGRA_IDMENSAGEM, @V_REGRA_IDTIPOREGISTRO, @V_REGRA_NRSEQDADOSFISC,
                                   @V_REGRA_CDCLASFISC, @V_REGRA_CDPRODUTO, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP;
      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT @V_EXISTE = COUNT(*)
           FROM INCITEMP
          WHERE NRINCITEMP  = @P_FILIAL+@P_LANCTONF
            AND CDIMPOTEMP = @V_REGRA_CDIMPOSTO;

         IF (@V_EXISTE > 0) BEGIN
            DELETE FROM INCITEMP
            WHERE NRINCITEMP  = @P_FILIAL+@P_LANCTONF
              AND CDIMPOTEMP = @V_REGRA_CDIMPOSTO;
         END;

         SELECT @V_IDTRATIMPO = MAX(IDTRATIMPO)
           FROM IMPOSTO
          WHERE CDIMPOSTO = @V_REGRA_CDIMPOSTO;

         IF @V_REGRA_IDMENSAGEM = 'S' BEGIN
            IF @V_REGRA_IDTIPOREGISTRO = 'PAD' BEGIN

               DECLARE C_MSGREGRA CURSOR FOR
                  SELECT DSMENSAGEM
                    FROM MSGFISCREGRA
                   WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                     AND CDIMPOSTO = @V_REGRA_CDIMPOSTO
                     AND NRSEQDADOSFISC = @V_REGRA_NRSEQDADOSFISC;
               OPEN C_MSGREGRA;
               FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  INSERT INTO INCITEMP
                    (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                     CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
                     CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
                  VALUES
                    (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
                     @V_REGRA_CDFISCAL, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
                     @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
                  FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
               END;
               CLOSE C_MSGREGRA;
               DEALLOCATE C_MSGREGRA;
            END
            ELSE BEGIN
               IF @V_REGRA_IDTIPOREGISTRO = 'NCM' BEGIN
                  DECLARE C_MSGREGRA CURSOR FOR
                     SELECT DSMENSAGEM
                       FROM MSGFISCNCM
                      WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                        AND CDIMPOSTO = @V_REGRA_CDIMPOSTO
                        AND CDCLASFISC = @V_REGRA_CDCLASFISC
                        AND NRSEQDADOSFISC = @V_REGRA_NRSEQDADOSFISC;
                  OPEN C_MSGREGRA;
                  FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     INSERT INTO INCITEMP
                       (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                        CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
                        CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
                     VALUES
                       (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
                        @V_REGRA_CDFISCAL, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
                        @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

                     SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
                     FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                  END;
                  CLOSE C_MSGREGRA;
                  DEALLOCATE C_MSGREGRA;
               END
               ELSE BEGIN
                  IF @V_REGRA_IDTIPOREGISTRO = 'PROD' BEGIN
                     DECLARE C_MSGREGRA CURSOR FOR
                        SELECT DSMENSAGEM
                          FROM MSGFISCPROD
                         WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                           AND CDIMPOSTO = @V_REGRA_CDIMPOSTO
                           AND NRSEQDADOSFISC = @V_REGRA_NRSEQDADOSFISC
                           AND CDPRODUTO = @V_REGRA_CDPRODUTO;
                     OPEN C_MSGREGRA;
                     FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                     WHILE (@@FETCH_STATUS = 0) BEGIN
                        INSERT INTO INCITEMP
                          (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
                           CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
                           CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
                        VALUES
                          (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
                           @V_REGRA_CDFISCAL, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
                           @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

                        SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
                        FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                     END;
                     CLOSE C_MSGREGRA;
                     DEALLOCATE C_MSGREGRA;
                  END;
               END;
            END;
         END
         ELSE BEGIN
            INSERT INTO INCITEMP
              (NRINCITEMP, NRSEQUINCI, CDIMPOTEMP, IDTRATIMPTMP,
               CDFISCTEMP, DSMENSINCTMP, CDINSCESTAITMP, CDDETALHEPROD, CDREGRATMP,
               CDENQLEGALIPI, CDCEST, VRADICALIQFECP)
            VALUES
              (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_REGRA_CDIMPOSTO, @V_IDTRATIMPO,
               @V_REGRA_CDFISCAL, NULL, NULL, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDREGRAFISC,
               @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP);

            SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(INT, @V_SEQUENCIA) + 1)),2)
         END;
         FETCH NEXT FROM C_REGRA INTO @V_REGRA_CDIMPOSTO, @V_REGRA_CDFISCAL, @V_REGRA_CDREGRAFISC, @V_REGRA_IDMENSAGEM, @V_REGRA_IDTIPOREGISTRO, @V_REGRA_NRSEQDADOSFISC,
                                   @V_REGRA_CDCLASFISC, @V_REGRA_CDPRODUTO, @V_REGRA_CDDETALHEFISC, @V_REGRA_CDENQLEGALIPI, @V_REGRA_CDCEST, @V_REGRA_VRADICALIQFECP;
      END;
      CLOSE C_REGRA;
      DEALLOCATE C_REGRA;

      FETCH NEXT FROM C_IMPINSCESTACL INTO @V_IMPINSCESTACL_CDIMPOSTO, @V_IMPINSCESTACL_CDGRUPOFISC;
   END;
   CLOSE C_IMPINSCESTACL;
   DEALLOCATE C_IMPINSCESTACL;            

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CONSULTA_INCIDENCIA','6.19.xxx';
GO

